'From Squeak 2.2 of Sept 23, 1998 on 22 November 1998 at 11:53:38 pm'!
Object subclass: #Matrix
	instanceVariableNames: 'rows matrixReducer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!
Object subclass: #MatrixReducer
	instanceVariableNames: 'matrix pivots detSign '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
MatrixReducer subclass: #EuclideanMatrixReducer
	instanceVariableNames: 'euclideanFunction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
Object subclass: #MonicMonomial
	instanceVariableNames: 'variables '
	classVariableNames: 'SortBlock '
	poolDictionaries: ''
	category: 'Math-Algebra'!
MonicMonomial subclass: #Monomial
	instanceVariableNames: 'coeficient '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!
Number subclass: #AlgebraicNumber
	instanceVariableNames: 'polynomial interval '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!
Object subclass: #OpenedInterval
	instanceVariableNames: 'left right '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Geometry'!
OpenedInterval subclass: #ClosedInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Geometry'!
Object subclass: #Polynomial
	instanceVariableNames: 'monomials '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!
Object subclass: #Sturn
	instanceVariableNames: 'polynomials '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algorithms'!
Object subclass: #Tuple
	instanceVariableNames: 'elements '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!
Object subclass: #Variable
	instanceVariableNames: 'name '
	classVariableNames: 'SortBlock '
	poolDictionaries: ''
	category: 'Math-Algebra'!
Variable subclass: #RaisedVariable
	instanceVariableNames: 'degree '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Algebra'!

!Object methodsFor: 'testing' stamp: 'r++ y ary 4/26/98 16:21'!
isFraction
	^ false! !

!Object methodsFor: 'testing' stamp: 'r++ 5/3/98 14:04'!
isMonicMonomial
	^ false! !

!Object methodsFor: 'testing' stamp: 'Gerardo Richarte 11/16/97 01:04'!
isMonomial
	^ false! !

!Object methodsFor: 'testing' stamp: 'Gerardo Richarte 11/16/97 01:04'!
isPolynomial
	^ false! !

!Object methodsFor: 'testing' stamp: 'Gerardo Richarte 11/16/97 01:29'!
isVariable
	^ false! !


!AlgebraicNumber class methodsFor: 'instance creation'!
fromNumber: aNumber
	" answer a new AlgebraicNumber that can represent aNumber"
	^ self
		polynomial: (RaisedVariable name: #x deg: 1) - aNumber
		interval: (ClosedInterval left: aNumber-1 right: aNumber+1)! !

!AlgebraicNumber class methodsFor: 'instance creation' stamp: 'r++ y ary 5/1/98 20:18'!
polynomial: aPolynomial interval: anInterval
	"Private - creates a new Algebraic number with the interval anInterval and the polynomial apolynomial"
	^ self new polynomial: aPolynomial ; interval: anInterval! !

!AlgebraicNumber class methodsFor: 'instance creation'!
root: anInteger of: anotherInteger
	"Public - creates a new Algebraic Number which is the anIntegerth root of anotherInteger. For example:
root: 3 of: 5"
	anInteger even ifTrue: [
		anotherInteger > 0 ifFalse: [ ^ self error: 'no existe la raiz'].
		^self polynomial: (RaisedVariable name: #x deg: anInteger) - anotherInteger
		interval: (ClosedInterval left: 1 right: anotherInteger)].
	^self polynomial: (RaisedVariable name: #x deg: anInteger) - anotherInteger
		interval: ((anotherInteger >= 0) ifTrue: [ClosedInterval left: 1 right: anotherInteger]
			ifFalse: [ClosedInterval left: anotherInteger right: -1])!
]style[(34 105 13 462)f1b,f1,f1PAlgebraicNumber root: 3 of: 5;;,f1! !

!AlgebraicNumber class methodsFor: 'instance creation'!
sqrt2
	" Public - gives the algebraic number sqrt of 2 , which is a particular case of the sqrtOf: method "
	^ self
		polynomial: (RaisedVariable name: #x deg: 2) - 2
		interval: (ClosedInterval left: 1 right: 2)! !

!AlgebraicNumber class methodsFor: 'instance creation'!
sqrtOf: anInteger
	" Public - gives a new AlgebraicNumber which is the square root of aNumber. For example: 
 sqrtOf: 5"
	"anInteger sqrt isInteger ifTrue: [^ anInteger sqrt]."
	^ self
		polynomial: (RaisedVariable name: #x deg: 2) - anInteger
		interval: (ClosedInterval left: 1 right: anInteger)!
]style[(17 91 1 10 178)f1b,f1,f1dAlgebraicNumber sqrtOf: 5;;,f1P AlgebraicNumber sqrtOf: 5;;,f1! !

!AlgebraicNumber class methodsFor: 'examples' stamp: 'ary 5/10/98 13:27'!
* anAlgebraicNumber
	"For more examples, you can play in the Morphic Word. Raiz de 2 * Raiz cubica de 5   = " !
]style[(21 54 9 3 16 3 1 3)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber root: 3 of: 5;;,f1,f1P AlgebraicNumber sqrt2 * ( AlgebraicNumber root: 3 of: 5);;,f1! !

!AlgebraicNumber class methodsFor: 'examples' stamp: 'ary 5/10/98 13:25'!
+ anAlgebraicNumber
	"For more examples, you can play in the Morphic Word. Raiz de 2 + Raiz cubica de 5 = " !
]style[(19 56 9 3 16 1 1 3)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber root: 3 of: 5;;,f1,f1P AlgebraicNumber sqrt2 + ( AlgebraicNumber root: 3 of: 5);;,f1! !

!AlgebraicNumber class methodsFor: 'examples' stamp: 'r++ 6/18/1998 14:59'!
aproximationError: aNumber
	"For more examples, you can play in the Morphic Word. Raiz de 2 aproximationError: 0.000001 "!
]style[(28 54 9 1 27 2)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 aproximationError: 0.000001;;,f1! !

!AlgebraicNumber class methodsFor: 'examples' stamp: 'ary 5/10/98 13:33'!
reciprocal
	"For more examples, you can play in the Morphic Word.  Raiz de 2  reciprocal "!
]style[(12 54 10 2 10 2)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 reciprocal;;,f1! !


!Matrix commentStamp: '<historical>' prior: 0!
M
atrix's instances represent Matrices...       
	       
	Matrices can be easly created with fromString: or newFrom: methods:    
	          
	Matrix newFrom:        
	' 1 54  6 8 98        
	  3  4 5  5 6       
	  3  2 2 2 4       
	  4 2 2 54 3'       
	       
	It accepts many representations: a line is divided by Character cr or $| and each line is treated as a Tuple. $( $) $  and $, are skeeped in Tuple #fromString: so this all mean the same: 
	    
	Matrix newFrom:     
	'1 2 3    
	 4 5 6    
	 7 8 9'   
	   
	Matrix newFrom:   
	'(1 2 3)   
	 (4 5 6)   
	 (7 8 9)'   
	  
	Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'  
	  
	and also...  
	  
	Matrix newFrom:  
	'(1(((,,)(		 2,,,))))3  
	 )))),,,4))()()()(5,,,,			6  
	)))))7))))))8(((((((,,,,,,)))))9(()))()'  
	  
	Matrices can be added, and multiplied:  
	  
	|a b|  
	a _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	b _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	a + b 
	 
	|a b|  
	a _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	b _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	a * b 

	and they can be reduced using a MatrixReducer: 
	 
	(Matrix fromString:
	'1 2 3 
	4 5 6 
	7 8 9' ) reduced 

	and 

	(Matrix fromString:
	'1 2 3 
	4 5 6 
	7 8 90' ) det
!
]style[(143 114 113 5 33 18 35 58 5 60 4 59 23 120 50 143 3 144 52 57 8 53)f1,f1P	Matrix newFrom:        
	' 1 54  6 8 98        
	  3  4 5  5 6       
	  3  2 2 2 4       
	  4 2 2 54 3'       
;;,f1,f1LTuple Comment;,f1,f1LTuple class fromString:;,f1,f1P	Matrix newFrom:     
	'1 2 3    
	 4 5 6    
	 7 8 9'   
;;,f1,f1P	Matrix newFrom:   
	'(1 2 3)   
	 (4 5 6)   
	 (7 8 9)'   
;;,f1,f1P	Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'  
;;,f1,f1P	Matrix newFrom:  
	'(1(((,,)(		 2,,,))))3  
	 )))),,,4))()()()(5,,,,			6  
	)))))7))))))8(((((((,,,,,,)))))9(()))()'  
;;,f1,f1P	|a b|  
	a _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	b _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	a + b 
;;,f1,f1P	|a b|  
	a _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	b _ Matrix fromString:  
	'(1,2,3)  
	 (4,5,6)  
	 (7,8,9)'. 
	a * b 
;;,f1,f1P	(Matrix fromString:
	'1 2 3 
	4 5 6 
	7 8 9' ) reduced 
;;,f1,f1P	(Matrix fromString:
	'1 2 3 
	4 5 6 
	7 8 90' ) det
;;!

!Matrix methodsFor: 'initialization'!
initializeMatrixReducer
	self matrixReducer: self class defaultMatrixReducer new! !

!Matrix methodsFor: 'initialization'!
initializeRows
	"private - sets the rows to be an empty OrderedCollection"
	^ self rows: OrderedCollection new! !

!Matrix methodsFor: 'initialization' stamp: 'r++ 12/7/97 23:53'!
rowClass
	" answer the proper class for my rows"
	^ Tuple! !

!Matrix methodsFor: 'accessing'!
at: aPoint
    "private - returns element at row@col in the matrix"
    ^(self row: aPoint y) at: aPoint x! !

!Matrix methodsFor: 'accessing'!
at: aPoint put: anElement
    "private - sets element at row@col in the matrix to be anElement"
    ^(self row: aPoint y) at: aPoint x put: anElement! !

!Matrix methodsFor: 'accessing'!
colDim
    "public - return number of rows (col dimension)"
    ^self rows size! !

!Matrix methodsFor: 'accessing' stamp: 'Gerardo Richarte 10/27/97 18:15'!
matrixReducer
	matrixReducer isNil ifTrue: [ self initializeMatrixReducer ].
	^ matrixReducer! !

!Matrix methodsFor: 'accessing' stamp: 'Gerardo Richarte 10/27/97 18:15'!
matrixReducer: aMatrixReducer
	matrixReducer _ aMatrixReducer ! !

!Matrix methodsFor: 'accessing'!
row: anIndex
    "private - returns the row number anIndex"
    ^self rows at: anIndex! !

!Matrix methodsFor: 'accessing'!
row: anIndex put: aTuple
    " sets the row anIndex = aTuple"
    ^self rows at: anIndex put: aTuple! !

!Matrix methodsFor: 'accessing'!
rowDim
    "public - return number of rows (col dimension)"
    ^self rows first size! !

!Matrix methodsFor: 'adding'!
addRow: aRow
    "private - adds a row at the bottom of the matrix"
    ^self rows add: aRow! !

!Matrix methodsFor: 'arithmetic' stamp: 'ary 5/10/98 18:24'!
* anObject
	"public - returns a new matrix that is self * anObject"
	| newRow answer |
	anObject isMatrix ifTrue:[
	answer _ self class new.
	self rows do: [:myRow |
		newRow _ nil.
		1 to: self rowDim do: [:each | 
			newRow _ newRow
				ifNil: [(anObject row: each) * (myRow at: each)]
				ifNotNil: [newRow + ((anObject row: each) * (myRow at: each))]].
		answer addRow: newRow].
	^ answer].
	anObject isNumber ifTrue: [^ self collect: [:each | each * anObject]]! !

!Matrix methodsFor: 'arithmetic'!
+ aMatrix
    "public - returns a new matrix that is self + aMatrix"
    |answer|
    answer := self class new.
    1 to: self colDim do: [:i |
        answer addRow: (self row: i) + (aMatrix row: i)].
    ^answer! !

!Matrix methodsFor: 'arithmetic'!
- aMatrix
    "public - returns a new matrix that is self - aMatrix"
    ^ self + aMatrix negated! !

!Matrix methodsFor: 'arithmetic' stamp: 'r++ 12/4/97 11:54'!
negated
    "public - returns a new matrix that is -self"
    |answer|
    answer _ self class new.
    self rows do: [:aRow |
        answer addRow: aRow negated].
    ^answer! !

!Matrix methodsFor: 'arithmetic' stamp: 'r++ 12/7/97 23:53'!
squared
	" public - answer myself squared"
	^ self * self! !

!Matrix methodsFor: 'matrix functions' stamp: 'r++ y ary 5/1/98 17:03'!
det
	^ (self matrixReducer matrix: self) det! !

!Matrix methodsFor: 'matrix functions' stamp: 'r++ y ary 5/3/98 16:00'!
nullRows
	" public - answer a collection of the indexes of my null rows"
	^ (1 to: self rowDim) select: [:each | (self row: each) isNull]! !

!Matrix methodsFor: 'matrix functions' stamp: 'r++ 5/3/98 16:22'!
permuteRow: anInteger withRow: bnInteger
	| aux |
	aux _ self row: anInteger.
	self row: anInteger put: (self row: bnInteger).
	self row: bnInteger put: aux.! !

!Matrix methodsFor: 'matrix functions'!
reduced
	^ (self matrixReducer matrix: self) reducedMatrix! !

!Matrix methodsFor: 'matrix functions' stamp: 'r++ 5/3/98 16:21'!
row: anIndex add: aTuple
    " friend - adds to row anIndex the row aTuple"
    ^self rows at: anIndex put: (aTuple + (self row: anIndex)).! !

!Matrix methodsFor: 'matrix functions' stamp: 'r++ 12/7/97 23:53'!
transposed
	" public - answer my transposed matrix"
	| answer newRow |
	answer _ self class new.
	1 to: self rowDim do: [:eachCol |
		newRow _ self rowClass new.
		self rows do: [:each |
			newRow add: (each at: eachCol)].
		answer addRow: newRow].
	^ answer! !

!Matrix methodsFor: 'comparing'!
= aMatrix
	1 to: self colDim do: [:eachIndex |
		(self row: eachIndex) = (aMatrix row: eachIndex) ifFalse: [^false]].
	^true! !

!Matrix methodsFor: 'comparing' stamp: 'ary 5/10/98 17:48'!
isMatrix
	^ true! !

!Matrix methodsFor: 'enumerating' stamp: 'r++ y ary 4/26/98 22:05'!
collect: aBlock
	| answer |
	answer _ self class new.
	self rows do: [:eachRow | answer addRow: (eachRow collect: aBlock)].
	^ answer! !

!Matrix methodsFor: 'converting' stamp: 'r++ 1/17/98 19:31'!
asGraph
	" public - answer a Graph whos Matrix representation is me"
	| answer |
	answer _ Graph new.
	1 to: self colDim do: [:eachRow |
		1 to: self rowDim do: [:eachCol |
			(self at: eachCol @ eachRow) = 0 ifFalse: [
				answer addArrowFrom: eachCol to: eachRow weighted: (self at: eachCol @ eachRow)]]].
	^ answer! !

!Matrix methodsFor: 'printing'!
printOn: aStream
    "public - returns the representation of self as a String"
	1 to: self colDim do: [:eachRow |    
        (self row: eachRow) printOn: aStream.
        aStream cr].! !

!Matrix methodsFor: 'copying'!
copy
^ self class new rows: self rows copy! !

!Matrix methodsFor: 'private'!
rows
    "private - returns the value of the internal variable rows"
	rows isNil ifTrue: [self initializeRows].
    ^rows! !

!Matrix methodsFor: 'private'!
rows: aValue
    "private - assigns the value of the internal variable rows
    and returns self"
    rows := aValue.
    ^self! !


!Matrix class methodsFor: 'defaults' stamp: 'Gerardo Richarte 10/27/97 18:17'!
defaultMatrixReducer
	^ MatrixReducer! !

!Matrix class methodsFor: 'instance creation' stamp: 'r++ 4/25/98 21:22'!
fromString: aString
    "public - return a new Matrix filled in with values from a string. See documentation
"

    |answer|
	answer _ self new.
    (aString findTokens: (Array with: Character cr with: $|)) do:
		[:eachLine | answer addRow: (answer rowClass fromString: eachLine)].
    ^answer.
! !

!Matrix class methodsFor: 'instance creation' stamp: 'ary 5/10/98 18:12'!
identity: anInteger
	| answer |
	answer _ Matrix new.
	1 to: anInteger do: [ :each | answer addRow: ( Tuple canonic: each dim: anInteger)].
	^ answer
	! !

!Matrix class methodsFor: 'instance creation' stamp: 'r++ 6/12/1998 15:46'!
newFrom: anObject
	(anObject isKindOf: String) ifTrue: [^self fromString: anObject].
	^nil! !


!MatrixReducer commentStamp: '<historical>' prior: 0!
A MatrixReducer consists in a matrix, as an instance variable, which will be reduced. For example: MatrixReducer aMatrix. You can ask for the reduced matrix an it's determinant

	#reduce guides the process, and #nextPivot and #killColumn makes the real job. By overriding only this two methods we've made an EuclideanMatrixReducer. !
]style[(99 13 1 7 22 14 9 12 2 7 25 10 5 11 40 16 39)f1,f1PMatrixReducer new matrix: (Matrix fromString: '1,2,3|2,7,3|5,0,1');;,f1,f1PMatrix fromString: '1,2,3|2,7,3|5,0,1';;,f1,f1P(MatrixReducer new matrix: (Matrix fromString: '1,2,3|2,7,3|5,0,1')) reduce;;,f1,f1P(MatrixReducer new matrix: (Matrix fromString: '1,2,3|2,7,3|5,0,1')) det;;,f1,f1LMatrixReducer reduce;,f1,f1LMatrixReducer killColumn. MatrixReducer nextPivot;,f1,f1LMatrixReducer killColumn. MatrixReducer nextPivot;,f1,f1LEuclideanMatrixReducer killColumn. EuclideanMatrixReducer nextPivot;,f1!

!MatrixReducer methodsFor: 'initialization'!
initialize
	"Private - initialize the reducer "
	self initializePivots.
	self privateDetSign: 1.! !

!MatrixReducer methodsFor: 'initialization' stamp: 'ary 5/10/98 17:35'!
initializePivots
	"Private - initializa the pivots "
    pivots _ OrderedCollection new.! !

!MatrixReducer methodsFor: 'accessing'!
det
	"public - I have some determinant stored, if pivots size = matrix rows it's OK,
	if not determinant must be 0"
	| answer |
	self reduce.
	answer _ self privateDetSign.
	1 to: self matrix rowDim do: [:each |
		answer _ answer * (self matrix at: each@each)].
	^ answer
! !

!MatrixReducer methodsFor: 'accessing' stamp: 'r++ y ary 5/3/98 16:10'!
matrix: aValue
	"assigns the value of the internal variable matrix and returns self"
	self initialize.
	self privateMatrix: aValue copy.
	^self! !

!MatrixReducer methodsFor: 'accessing'!
reducedMatrix
    " public - returns the reduced matrix (compute if needed) "
    self reduce.
    ^self matrix.! !

!MatrixReducer methodsFor: 'accessing'!
unusedRows
    " Return a Set of rows where there are no pivots at the moment"
    ^(1 to: self matrix colDim) asSet removeAll: self usedRows ; yourself! !

!MatrixReducer methodsFor: 'accessing'!
usedRows
    " Return a Set of rows where there are pivots at the moment"
    ^(self pivots collect: [:eachPivot | eachPivot y]) asSet.! !

!MatrixReducer methodsFor: 'printing'!
printOn: aStream
    self matrix printOn: aStream.! !

!MatrixReducer methodsFor: 'private-accessing'!
matrix
    "returns the value of the internal variable matrix"
    ^matrix! !

!MatrixReducer methodsFor: 'private-accessing'!
pivot
    " private - returns the current pivot"
    ^self pivots isEmpty
        ifTrue: []
        ifFalse: [self pivots last]! !

!MatrixReducer methodsFor: 'private-accessing'!
pivots
    "returns the value of the internal variable pivots"
	pivots isNil ifTrue: [self initializePivots].
    ^pivots! !

!MatrixReducer methodsFor: 'private-accessing'!
pivots: aValue
    "assigns the value of the internal variable pivots
    and returns self"
    pivots := aValue.
    ^self! !

!MatrixReducer methodsFor: 'private-accessing' stamp: 'ari y r++ 6/25/1998 00:19'!
privateDetSign
	^ detSign! !

!MatrixReducer methodsFor: 'private-accessing' stamp: 'ari y r++ 6/25/1998 00:20'!
privateDetSign: aNumber
	detSign _ aNumber! !

!MatrixReducer methodsFor: 'private-accessing' stamp: 'Gerardo Richarte 11/13/97 18:08'!
privateMatrix: aMatrix
    "assigns the value of the internal variable matrix"
    matrix _ aMatrix! !

!MatrixReducer methodsFor: 'private-proccess' stamp: 'r++ y ary 5/1/98 19:01'!
killColumn
	" private - kills a column of the matrix using the current pivot "
	| pivotRow |
	pivotRow _ (self matrix row: self pivot y) * (self matrix at: self pivot) reciprocal.
	pivotRow _ pivotRow negated.
	((1 to: self matrix colDim) asSet remove: self pivot y;	yourself)
		do: [:eachRow |
		self matrix
			row: eachRow 
			add: pivotRow * (self matrix at: self pivot x@eachRow)]! !

!MatrixReducer methodsFor: 'private-proccess' stamp: 'r++ y ary 5/1/98 19:30'!
nextPivot
	" private - Returns the next free pivot"
	| col unusedRows |
	unusedRows _ self unusedRows.
	col _ (self pivot isNil
				ifTrue: [0]
				ifFalse: [self pivot x])
				+ 1.
	[col <= self matrix rowDim]
		whileTrue: 
			[unusedRows do: [:eachRow | (self matrix at: col @ eachRow)
					isNull not ifTrue: [^ col @ eachRow]].
			col _ col + 1].
	^ nil ! !

!MatrixReducer methodsFor: 'private-proccess' stamp: 'r++ 6/14/1998 18:04'!
reduce
	" private - Directs the reducer algorithm"
	| pivot |
	[(pivot _ self nextPivot) isNil not] whileTrue: [
		self pivots add: pivot.
		self killColumn.
		self updateMorph].
	self triangulate.! !

!MatrixReducer methodsFor: 'private-proccess'!
triangulate
	" private - In this implementation when the algorithm finish the
	 matrix is already triangulated"
	1 to: self matrix rowDim do: [:each |
		self matrix
			permuteRow: ((each to: self matrix rowDim) detect: [:another |
				(self matrix at: each@another) isNull not] ifNone: [
					self privateDetSign: self privateDetSign negated.
					each])
			withRow: each.
		self privateDetSign: self privateDetSign negated]
		! !


!EuclideanMatrixReducer commentStamp: '<historical>' prior: 0!
An EuclideanMatrixReducer is stored as a matrix with coefficients in an Euclidean domain and the respective euclidean function. Because I'm a subclass of MatrixReducer, I has a few methods. The creation method is for example:
	EuclideanMatrixReducer matrix: aMatrix euclideanFunction: grado.
You can play in Morphic word to see al the things I can do. !
]style[(154 13 60 22 9 7 1 19 5 62)f1,f1LMatrixReducer Comment;,f1,f1d|x|
x _ Variable name: #x.
(EuclideanMatrixReducer new matrix:(Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x);yourself) euclideanFunction: [: a| a deg]) inspect;;,f1,f1P|x|
x _ Variable name: #x.
Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x); yourself;;,f1P|x|
x _ Variable name: #x.
Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x); yourself;;,f1,f1P'[:p | p deg]';;,f1!

!EuclideanMatrixReducer methodsFor: 'private - procces' stamp: 'r++ y ary 4/26/98 22:25'!
killColumn
	" private - kills a column of the matrix using the current pivot "
	| pivotRow pivotValue |
	pivotValue _ self matrix at: self pivot.
	pivotRow _ (self matrix row: self pivot y) negated.
	((1 to: self matrix colDim) asSet remove: self pivot y;	yourself)
		do: [:eachRow |
		self matrix
			row: eachRow
			add: pivotRow * ((self matrix at: self pivot x@eachRow) // pivotValue)]! !

!EuclideanMatrixReducer methodsFor: 'private - procces' stamp: 'r++ 5/3/98 17:51'!
nextPivot
	" private - Returns the next free pivot"
	| col unusedRows candidates pivotCol |
	unusedRows _ self unusedRows.
	pivotCol _ col _ self pivot isNil
						ifTrue: [1]
						ifFalse: [self pivot x].
	[col <= self matrix rowDim and: [unusedRows isEmpty not]]
		whileTrue: [
			candidates _ SortedCollection sortBlock: [:a :b | a key < b key].
			unusedRows do: [:eachRow |
				(self matrix at: col@eachRow) isNull ifFalse: [
					candidates add: (euclideanFunction value: (self matrix at: col @ eachRow)) -> eachRow]].
			candidates isEmpty ifFalse: [
				candidates _ candidates first value.
				(pivotCol = col and: [self pivots isEmpty not])
					ifTrue: [self pivots removeLast].
				^ col @ candidates].
			col _ col + 1].
	^ nil! !

!EuclideanMatrixReducer methodsFor: 'accesing' stamp: 'r++ 5/3/98 20:56'!
matrix: aMatrix 
	self matrix: aMatrix euclideanFunction: [:x | x abs].! !

!EuclideanMatrixReducer methodsFor: 'accesing' stamp: 'r++ y ary 4/26/98 18:56'!
matrix: aMatrix euclideanFunction: aOneArgumentBlock
	super matrix: aMatrix.
	euclideanFunction _ aOneArgumentBlock! !


!MonicMonomial commentStamp: '<historical>' prior: 0!
My instances represents MonicMonomials, they are stored as a SortedCollection (sorted in lexicografical order) of Variables!
]style[(61 16 2 30 5 8 1)f1,f1LSortedCollection Comment;,f1,f1LMonicMonomial class initialize. MonicMonomial class sortBlock. SortedCollection <;,f1,f1LVariable Comment;,f1!

!MonicMonomial reorganize!
('initialization' initializeVariables)
('arithmetic' * + - / // \\ negated reciprocal)
('accesing' add: at: at:put: name remove: removeAllVariables size variables)
('comparing' = hash isMonicMonomial isNull lexSmallerThan:)
('MonicMonomial functions' deg derivativeIn: raisedToInteger: value:at: valueAt:)
('enumerating' do: monomialsDo:)
('copying' copy)
('printing' printOn:)
('private' variableAt:ifNone: variables:)
('converting' , adaptFloat: adaptFraction: adaptInteger: adaptMonomial: adaptNumber: adaptPolynomial: adaptToFloat adaptToFraction adaptToInteger adaptToMonomial adaptToNumber adaptToPolynomial adaptToVariable adaptVariable: asMonomial asMonomialIn: asPolynomial asPolynomialIn:)
!


!MonicMonomial methodsFor: 'initialization'!
initializeVariables
	" variables stores all my variables"
	self variables: (SortedCollection sortBlock: RaisedVariable sortBlock)! !

!MonicMonomial methodsFor: 'arithmetic' stamp: 'ary 5/10/98 14:22'!
* anObject
	" public - answer a new MonicMonomial that is myself * anObject"
	| answer |
	^ (anObject isMonicMonomial or: [self isMonomial])
		ifTrue: [
			answer _ self copy.
			anObject do: [:eachVariable |
				answer
					at: eachVariable
					put: (self at: eachVariable) + (anObject at: eachVariable)].
			answer]
		ifFalse: [(anObject adaptMonicMonomial: self)*(anObject adaptToMonicMonomial)]! !

!MonicMonomial methodsFor: 'arithmetic' stamp: 'r++ 6/19/1998 23:37'!
+ aMonicMonomial
	^ self asMonomial + aMonicMonomial! !

!MonicMonomial methodsFor: 'arithmetic' stamp: 'r++ 5/3/98 20:58'!
- anObject
	" public - obvious"
	^ self + anObject negated! !

!MonicMonomial methodsFor: 'arithmetic'!
/ aMonicMonomial 
	" public - answer a new MonicMonomial that is myself / aMonicMonomial"
	^ self * aMonicMonomial reciprocal! !

!MonicMonomial methodsFor: 'arithmetic'!
// anObject
	^ self asPolynomial // anObject!
]style[(22 13 9)f1,f1LPolynomial //;,f1! !

!MonicMonomial methodsFor: 'arithmetic'!
\\ anObject
	^ self asPolynomial \\ anObject!
]style[(22 13 9)f1,f1LPolynomial \\;,f1! !

!MonicMonomial methodsFor: 'arithmetic' stamp: 'r++ 5/3/98 20:59'!
negated
	" public - answer a Monomial representing my additive inverse"
	^ self asMonomial negated! !

!MonicMonomial methodsFor: 'arithmetic'!
reciprocal
	" public - answer my reciprocal. It's a Monomial containing the my variables' reciprocals"
	| answer |
	answer _ self class new .
	self do: [:eachVar | answer add: eachVar reciprocal].
	^ answer! !

!MonicMonomial methodsFor: 'accesing' stamp: 'r++ 6/19/1998 23:44'!
add: aVariable
	"private - add myself a Variable "
	aVariable deg ~= 0 ifTrue: [self variables add: aVariable]! !

!MonicMonomial methodsFor: 'accesing'!
at: aVariable
	" public - answers degree of aVariable in self "
	^(self variableAt: aVariable ifNone: [^0]) deg! !

!MonicMonomial methodsFor: 'accesing'!
at: aVariable put: anInteger 
	" public - sets the degree of aVariable"
	self remove: aVariable.
	^ self add: (aVariable clone deg: anInteger)! !

!MonicMonomial methodsFor: 'accesing'!
name
	" public - answer my name (it's my variables' name concatenated)"
	| answer |
	answer _ String new.
	self variables do: [:eachVar | answer _ answer , eachVar name].
	^ answer asSymbol! !

!MonicMonomial methodsFor: 'accesing' stamp: 'r++ 6/19/1998 23:45'!
remove: aVariable 
	" public - removes aVariable"
	self variables remove: (self variableAt: aVariable ifNone: [nil]) ifAbsent: [nil]! !

!MonicMonomial methodsFor: 'accesing'!
removeAllVariables
	^ self initializeVariables! !

!MonicMonomial methodsFor: 'accesing' stamp: 'r++ 12/18/96 17:13'!
size
	" public - answers how many variables I have "
	^ self variables size! !

!MonicMonomial methodsFor: 'accesing' stamp: 'r++ 12/18/96 17:35'!
variables
	variables ifNil: [self initializeVariables].
	^ variables! !

!MonicMonomial methodsFor: 'comparing'!
= aMonicMonomial
	" public - answer whether aMonicMonomial is equal to myself"
	^ self class == aMonicMonomial class and: [
		self variables = aMonicMonomial variables]! !

!MonicMonomial methodsFor: 'comparing'!
hash
	" public - answer my hash"
	| answer |
	answer _ 0.
	self do: [:eachVar | answer _ answer + eachVar hash].
	^ answer hash.! !

!MonicMonomial methodsFor: 'comparing' stamp: 'r++ 5/3/98 14:00'!
isMonicMonomial
	^ true! !

!MonicMonomial methodsFor: 'comparing'!
isNull

	^ false! !

!MonicMonomial methodsFor: 'comparing'!
lexSmallerThan: aMonicMonomial 
	" public - answer whether I'm smaller than aMonicMonomial, lexicografical order "
	self deg = aMonicMonomial deg
		ifFalse: [^ self deg < aMonicMonomial deg].
	^ self variables < aMonicMonomial variables.!
]style[(30 170 26 11)f1b,f1,f1LSortedCollection <;,f1! !

!MonicMonomial methodsFor: 'MonicMonomial functions'!
deg
	" public - answer my degree. It's the addition of my variables' degrees"
	| answer |
	answer _ 0.
	self do: [:eachVar | answer _ answer + eachVar deg].
	^ answer! !

!MonicMonomial methodsFor: 'MonicMonomial functions'!
derivativeIn: aVariable
	" public - answer my derivative in aVariable"
	^ Monomial
		monicMonomial: (self copy at: aVariable put: ((self at: aVariable) - 1))
		coef: (self at: aVariable)! !

!MonicMonomial methodsFor: 'MonicMonomial functions'!
raisedToInteger: anInteger 
	"Public - gives the resulting Monomial after elevating me to the anIntegerth power"
	| mid |
	anInteger < 0 ifTrue: [^ (self raisedToInteger: anInteger negated) reciprocal].
	anInteger = 0 ifTrue: [^ 1].
	anInteger = 1 ifTrue: [^ self].
	mid _ anInteger // 2.
	^ (self raisedToInteger: anInteger - mid)
		* (self raisedToInteger: mid)! !

!MonicMonomial methodsFor: 'MonicMonomial functions'!
value: aVariable at: anObject
	" public - evaluates myself when aVariable is anObject"
	| var |
	^ ((var _ self variableAt: aVariable ifNone: [nil])
		ifNil: [self]
		ifNotNil: [((self copy remove: aVariable)*(var valueAt: anObject))]) asSimplePolynomial! !

!MonicMonomial methodsFor: 'MonicMonomial functions'!
valueAt: anObject
	" public - evaluates myself at anObject"
	^ self variables isEmpty
		ifTrue: [self asSimplePolynomial]
		ifFalse: [self value: (self variables first) at: anObject]! !

!MonicMonomial methodsFor: 'enumerating' stamp: 'r++ 12/18/96 17:13'!
do: aBlock 
	" public - with each Variable do aBlock"
	self variables do: aBlock! !

!MonicMonomial methodsFor: 'enumerating'!
monomialsDo: aBlock
	" public - added so a MonicMonomial can be easly added to a Polynomial"
	aBlock value: self asMonomial! !

!MonicMonomial methodsFor: 'copying'!
copy
	^ self clone variables: self variables copy! !

!MonicMonomial methodsFor: 'printing'!
printOn: aStream
	"public - my printed representation is a concatenation of my variables' printed representation"
	| first |
	first _ true.
	self variables do: 
		[:eachVariable | 
		first ifTrue: [first _ false] ifFalse: [aStream nextPut: $*].
		eachVariable printOn: aStream].
	first ifTrue: [1 printOn: aStream].! !

!MonicMonomial methodsFor: 'private'!
variableAt: aVariable ifNone: exceptionBlock 
	" private - answers the variable whos name matches aVariable name if none value exceptionBlock"
	| index |
	index _ self variables findFirst: [:eachVar | eachVar sameAs: aVariable].
	^ index ~= 0
		ifTrue: [ self variables at: index]
		ifFalse: [ exceptionBlock value]! !

!MonicMonomial methodsFor: 'private' stamp: 'r++ 12/18/96 17:14'!
variables: aSortedCollection
	variables _ aSortedCollection! !

!MonicMonomial methodsFor: 'converting' stamp: 'ary 5/10/98 16:15'!
, anObject
	"Public - answer a Tuple with myself and anObject"
	^ (Tuple new add: self ; add: anObject)! !

!MonicMonomial methodsFor: 'converting'!
adaptFloat: aNumber
	^ self adaptNumber: aNumber! !

!MonicMonomial methodsFor: 'converting'!
adaptFraction: aNumber
	^ self adaptNumber: aNumber! !

!MonicMonomial methodsFor: 'converting'!
adaptInteger: aNumber
	^ self adaptNumber: aNumber! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 12/18/96 16:38'!
adaptMonomial: aMonomial
	"If a Monomial is involved in arithmetic with me answer the Monomial represented in the smaller ring containing both rings involved (my own and Monomial's: Monomial's)"
	^ aMonomial! !

!MonicMonomial methodsFor: 'converting'!
adaptNumber: aNumber
	^ Monomial number: aNumber! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 12/18/96 16:44'!
adaptPolynomial: aPolynomial
	"If a Polynomial is involved in arithmetic with me answer the Polynomial represented in the smaller ring containing both rings involved (my own and Polynomial's: Polynomial's)"
	^ aPolynomial! !

!MonicMonomial methodsFor: 'converting'!
adaptToFloat
	^ self adaptToNumber! !

!MonicMonomial methodsFor: 'converting'!
adaptToFraction
	^ self adaptToNumber! !

!MonicMonomial methodsFor: 'converting'!
adaptToInteger
	^ self adaptToNumber! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 12/18/96 16:38'!
adaptToMonomial
	"If I am involved in arithmetic with a Monomial answer myself represented in the smaller ring containing both rings involved (my own and Monomial's): Monomial"
	^ self asMonomial! !

!MonicMonomial methodsFor: 'converting'!
adaptToNumber
	^ Monomial monic: self! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 12/18/96 16:43'!
adaptToPolynomial
	"If I am involved in arithmetic with a Polynomial answer myself represented in the smaller ring containing both rings involved (my own and Polynomial's): Polynomial"
	^ self asPolynomial! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 14:59'!
adaptToVariable
	" answer a Monomial that represents the given number"
	^ self! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 4/25/98 17:58'!
adaptVariable: aVariable
	" answer a Monomial that represents the given number"
	^ aVariable asMonomial! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 5/3/98 14:02'!
asMonomial
	" answer a Monomial representing me"
	^ Monomial fromMonicMonomial: self! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 5/3/98 14:01'!
asMonomialIn: aVariable
	" answer myself coverted to a Monomial expressend in aVariable"
	^ Monomial
		monicMonomial: (MonicMonomial fromVariable: (self variableAt: aVariable ifNone: [MonicMonomial new]))
		coef: (self copy remove: aVariable)! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ 12/18/96 16:43'!
asPolynomial
	" answer a Polynomial representing me"
	^ Polynomial with: self asMonomial! !

!MonicMonomial methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 15:06'!
asPolynomialIn: aVariable
	" answer a Polynomial representing me expressend in aVariable"
	^ self asPolynomial asPolynomialIn: aVariable! !


!MonicMonomial class reorganize!
('initialization' initialize)
('instance creation' fromVariable: variable: variable:deg:)
('accessing' sortBlock)
!


!MonicMonomial class methodsFor: 'initialization' stamp: 'r++ 6/19/1998 23:29'!
initialize
	"MonicMonomial initialize"
	SortBlock _ [:a :b | (b lexSmallerThan: a) not]
!
]style[(10 54 15 9)f1b,f1,f1LMonicMonomial lexSmallerThan:. Variable lexSmallerThan:;,f1! !

!MonicMonomial class methodsFor: 'instance creation'!
fromVariable: aVariable
	" answer a MonicMonomial representing aVariable"
	^ self new add: aVariable; yourself! !

!MonicMonomial class methodsFor: 'instance creation'!
variable: aString 
	" public - answers a MonicMonomial that represents a single variable, 
	  it's usefull for cerating Polynomials as in: 
	| x y | 
	x _ MonicMonomial variable: #x. 
	y _ MonicMonomial variable: #y. 
	x*x*(x*y*y*y) "
	^ self new add: (RaisedVariable name: aString); yourself!
]style[(17 123 92 60)f1b,f1,f1P	| x y | 
	x _ MonicMonomial variable: #x. 
	y _ MonicMonomial variable: #y. 
	x*x*(x*y*y*y);;,f1! !

!MonicMonomial class methodsFor: 'instance creation'!
variable: aSymbol deg: anInteger
	" public - answers a MonicMonomial that represents a single variable elevated to anInteger power, 
	  it's usefull for cerating literals as in: 
	| y2 x3 | 
	x3 _ MonicMonomial variable: #x deg: 3. 
	y2 _ MonicMonomial variable: #x deg: 2.
	x3+y2"
	^ self new add: (RaisedVariable name: aSymbol deg: anInteger); yourself!
]style[(32 147 101 74)f1b,f1,f1P	| y2 x3 | 
	x3 _ MonicMonomial variable: #x deg: 3. 
	y2 _ MonicMonomial variable: #x deg: 2.
	x3+y2;;,f1! !

!MonicMonomial class methodsFor: 'accessing'!
sortBlock
	" my SortBlock determines how MonicMonomials and Monomials must be sorted when they are stored in a collection.
	Simply by changing my #initialize you can change the order in which a Polynomial is displayed"
	^ SortBlock!
]style[(10 31 13 6 8 78 11 37 10 27)f1b,f1,f1LMonicMonomial Comment;,f1,f1LMonomial Comment;,f1,f1LMonicMonomial class initialize;,f1,f1LPolynomial Comment;,f1! !


!Monomial commentStamp: '<historical>' prior: 0!
A Monomial is a MonicMonomial multiplied by a coeficient.
It's interesting to see how the implementation of #value:at: in MonicMonomial also solves #value:at: for Monomials!
]style[(16 13 17 10 52 10 54)f1,f1LMonicMonomial Comment;,f1,f1LMonomial Definition;,f1,f1LMonicMonomial value:at:;,f1!

!Monomial methodsFor: 'initilization'!
initializeCoeficient
	self coef: 0! !

!Monomial methodsFor: 'arithmetic'!
* anObject
	"public - answer the product of myself and anObject"
	^ anObject isMonomial
		ifTrue: [(super * anObject) coef: (self coef * anObject coef)]
		ifFalse: [(anObject adaptMonomial: self)*(anObject adaptToMonomial)]
!
]style[(11 54 159)f1b,f1,f1cblack;! !

!Monomial methodsFor: 'arithmetic'!
+ anObject
	" public - if my MonicMonomial = aMonomial's MonicMonomial answer a monomial, if not answer a Polynomial"
	^ anObject isMonomial
		ifTrue: [
			super = anObject
				ifTrue: [self class monicMonomial: self coef: (self coef + anObject coef)]
				ifFalse: [Polynomial with: self with: anObject]]
		ifFalse: [(anObject adaptMonomial: self)+(anObject adaptToMonomial)]! !

!Monomial methodsFor: 'arithmetic'!
negated
	" public - answers my additive inverse "
	^ self copy coef: self coef negated! !

!Monomial methodsFor: 'arithmetic' stamp: 'r++ y ary 4/26/98 21:25'!
reciprocal

	^ super reciprocal coef: self coef reciprocal! !

!Monomial methodsFor: 'accessing'!
coef
	coeficient ifNil: [self initializeCoeficient].
	^ coeficient! !

!Monomial methodsFor: 'accessing'!
coef: aCoeficient 
	coeficient _ aCoeficient.
	self coef isNull ifTrue: [self removeAllVariables]! !

!Monomial methodsFor: 'accessing' stamp: 'r++ y ary 4/26/98 20:15'!
lc
	^ self coef asSimplePolynomial! !

!Monomial methodsFor: 'monomial functions'!
derivativeIn: aVariable
	" public - answer my derivative in aVariableOrMonicMonomial"
	| answer |
	answer _ (super derivativeIn: aVariable).
	answer coef: (answer coef*self coef).
	^ answer! !

!Monomial methodsFor: 'comparing'!
= aMonomial
	^ super = aMonomial and: [self coef = aMonomial coef]! !

!Monomial methodsFor: 'comparing'!
hash
	^ (super hash * self coef hash) hash! !

!Monomial methodsFor: 'comparing'!
isMonic
	^ self coef * self coef = self coef! !

!Monomial methodsFor: 'comparing' stamp: 'r++ 5/3/98 13:58'!
isMonicMonomial
	^ false! !

!Monomial methodsFor: 'comparing' stamp: 'r++ 12/18/96 20:17'!
isNull
	^ self coef isNull! !

!Monomial methodsFor: 'comparing'!
negative
	" public - answers whether my coeficient is negative or not"
	^ self coef negative! !

!Monomial methodsFor: 'printing' stamp: 'r++ 12/18/96 17:14'!
printOn: aStream 
	self variables size = 0
		ifTrue: [self coef printOn: aStream]
		ifFalse: [
			self coef ~= 1 ifTrue: [
				self coef printOn: aStream.
				aStream nextPut: $*].
			super printOn: aStream]! !

!Monomial methodsFor: 'copying'!
copy
	^ super copy coef: self coef copy! !

!Monomial methodsFor: 'converting'!
adaptFloat: aNumber
	" answer a Monomial that represents the given number"
	^ self adaptNumber: aNumber! !

!Monomial methodsFor: 'converting'!
adaptFraction: aNumber
	" answer a Monomial that represents the given number"
	^ self adaptNumber: aNumber! !

!Monomial methodsFor: 'converting'!
adaptInteger: aNumber
	" answer a Monomial that represents the given number"
	^ self adaptNumber: aNumber! !

!Monomial methodsFor: 'converting'!
adaptLiteral: aLiteral
	" answer a Monomial that represents the given number"
	^ Monomial monic: aLiteral! !

!Monomial methodsFor: 'converting' stamp: 'r++ 5/3/98 13:55'!
adaptMonicMonomial: aMonicMonomial
	" answer a Monomial that represents the given MonicMonomial"
	^ aMonicMonomial asMonomial! !

!Monomial methodsFor: 'converting'!
adaptNumber: aNumber
	" answer a Monomial that represents the given number"
	^ Monomial fromNumber: aNumber! !

!Monomial methodsFor: 'converting'!
adaptToFloat
	" answer myself, becouse the integer is what shuld be converted to a Monomial"! !

!Monomial methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 15:41'!
adaptToFraction
	" answer myself, becouse the integer is what should be converted to a Monomial"! !

!Monomial methodsFor: 'converting'!
adaptToInteger
	" answer myself, becouse the integer is what shuld be converted to a Monomial"! !

!Monomial methodsFor: 'converting' stamp: 'r++ 5/3/98 13:57'!
adaptToMonicMonomial
	"  answer myself, becouse the Monic Monomial is what should be converted to a Monomial"
	^ self! !

!Monomial methodsFor: 'converting'!
adaptToNumber
	" answer myself, becouse the integer is what shuld be converted to a Monomial"
! !

!Monomial methodsFor: 'converting' stamp: 'r++ 4/25/98 17:46'!
asMonomial
	^ self! !

!Monomial methodsFor: 'converting' stamp: 'r++ 4/25/98 18:18'!
asSimplePolynomial
	| answer |
	answer _ self coef.
	answer isNumber ifFalse: [answer _ answer asSimplePolynomial].
	self do: [:eachVar |
		answer _ answer * eachVar].
	^ answer! !

!Monomial methodsFor: 'converting'!
isMonomial
	^ true
	
		! !


!Monomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 14:02'!
fromMonicMonomial: aMonicMonomial
	^ self monicMonomial: aMonicMonomial coef: 1! !

!Monomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 14:03'!
fromNumber: aNumber 
	" public - answer a Monomial that represents a Number"
	^ self monicMonomial: MonicMonomial new coef: aNumber! !

!Monomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 21:20'!
generalNull
	" public - answer a monomial that represents zero with 0 as coeficient.
	  It may not be the apropiate for some type of monomials: when coeficient is not a Number"
	^ self fromNumber: 0! !

!Monomial class methodsFor: 'instance creation'!
literal: aLiteral coef: aCoeficient 
	^ self new variables: aLiteral variables;
	 coef: aCoeficient! !

!Monomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 14:03'!
monic: aMonicMonomial
	^ self monicMonomial: aMonicMonomial coef: 1! !

!Monomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 14:00'!
monicMonomial: aMonicMonomial coef: aCoeficient 
	^ Monomial new variables: aMonicMonomial variables;
	 coef: aCoeficient! !

!Monomial class methodsFor: 'instance creation'!
number: aNumber
	" public - answer a Monomial that represents a Number"
	^ self fromNumber: aNumber! !

!Monomial class methodsFor: 'instance creation'!
variable: aString
	" public - answer a Monomial that represents a Variable whos name is aString"
	^ (super variable: aString)
		coef: 1! !

!Monomial class methodsFor: 'instance creation'!
variable: aString deg: anInteger
	" public - answer a Monomial that represents a Variable whos name is aString"
	^ (super variable: aString deg: anInteger)
		coef: 1! !


!Number reorganize!
('arithmetic' * + - / // \\ abs negated quo: reciprocal rem:)
('mathematical functions' arcCos arcSin arcTan cos exp floorLog: ln log log: raisedTo: raisedToInteger: sin sqrt squared tan)
('truncation and round off' ceiling detentBy:atMultiplesOf:snap: floor roundTo: roundUpTo: rounded truncateTo: truncated)
('testing' basicType even isFloat isFraction isInf isInfinite isInteger isNaN isNull isNumber negative odd positive sign strictlyPositive)
('converting' , @ adaptFloat: adaptFraction: adaptInteger: adaptToFloat adaptToFraction adaptToInteger asInteger asPoint asSmallAngleDegrees degreesToRadians radiansToDegrees)
('intervals' to: to:by: to:by:do: to:do:)
('printing' defaultLabelForInspector newTileMorphRepresentative printOn: printStringBase: storeOn: storeOn:base: storeStringBase: stringForReadout)
('Polynomial support' adaptMonicMonomial: adaptMonomial: adaptPolynomial: adaptToMonicMonomial adaptToMonomial adaptToPolynomial adaptToVariable adaptVariable: asMonomial asPolynomial asSimplePolynomial)
('AlgebraicNumber support' adaptAlgebraicNumber: adaptToAlgebraicNumber asAlgebraicNumber isAlgebraic)
!


!Number methodsFor: 'testing' stamp: 'Gerardo Richarte 11/1/97 08:06'!
isNull
	"Answers if I'm 0 or not"
	^ self == 0! !

!Number methodsFor: 'converting' stamp: 'r++ 6/12/1998 15:27'!
, aNumber
	"Public - answer a Tuple with myself and aNumber"
	^ (Tuple new add: self ; add: aNumber)!
]style[(30 5 65)f1,f1LTuple Comment;,f1! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 5/3/98 14:04'!
adaptMonicMonomial: aMonicMonomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aMonicMonomial asMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 16:37'!
adaptMonomial: aMonomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 17:52'!
adaptPolynomial: aPolynomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aPolynomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 5/3/98 14:04'!
adaptToMonicMonomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 16:38'!
adaptToMonomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 17:53'!
adaptToPolynomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asPolynomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ y ary 4/26/98 16:53'!
adaptToVariable
	"If I am involved in arithmetic with a Variable, I must know whether to be converted."
	^ self asMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ y ary 4/26/98 16:53'!
adaptVariable: aVariable
	"If I am involved in arithmetic with a Variable, I must know whether to convert it."
	^ aVariable asMonomial! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 17:54'!
asMonomial
	"Answer a Monomial that represents me"

	^ Monomial fromNumber: self! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ 4/25/98 17:54'!
asPolynomial
	"Answer a Monomial that represents me"

	^ Polynomial fromNumber: self! !

!Number methodsFor: 'Polynomial support' stamp: 'r++ y ary 4/26/98 20:16'!
asSimplePolynomial
	"Answer a Monomial that represents me"

	^ self! !

!Number methodsFor: 'AlgebraicNumber support' stamp: 'r++ 6/18/1998 18:00'!
adaptAlgebraicNumber: anAlgebraicNumber
	^ anAlgebraicNumber! !

!Number methodsFor: 'AlgebraicNumber support' stamp: 'r++ 6/18/1998 18:00'!
adaptToAlgebraicNumber
	^ self asAlgebraicNumber! !

!Number methodsFor: 'AlgebraicNumber support' stamp: 'r++ 6/18/1998 18:00'!
asAlgebraicNumber
	^ (Smalltalk at: #AlgebraicNumber) fromNumber: self! !

!Number methodsFor: 'AlgebraicNumber support' stamp: 'r++ 5/3/98 14:24'!
isAlgebraic
	^ false! !


!AlgebraicNumber commentStamp: '<historical>' prior: 0!
An algebraic number is stored, in this implementation, as a  square free polynomial and a ClosedInterval wich contains an only root of the polynoial ( to determine the number of roots I use Sturn). For example: Raiz de 2 aproximationError: 1e-10
For another examples see sqrtOf: anInteger. For examples of some methods, see the category examples.
!
]style[(60 12 118 5 15 10 25 26 17 59)f1,f1LPolynomial squareFree;,f1,f1LSturn Comment;,f1,f1PAlgebraicNumber sqrt2;;,f1PAlgebraicNumber sqrt2 aproximationError: 1e-10;;,f1,f1LAlgebraicNumber class sqrtOf:;,f1!

!AlgebraicNumber methodsFor: 'accesing' stamp: 'ary 5/10/98 13:35'!
interval
	"Public - answer the interval who includes me as the only root of the polynomial. For example:  Raiz de 2  interval "
	^ interval!
]style[(8 98 9 2 8 14)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 interval;;,f1! !

!AlgebraicNumber methodsFor: 'accesing' stamp: 'ary 5/10/98 13:36'!
polynomial
	"Public - answer the polynomial who anules me. For example:  Raiz de 2  polynomial "
	^ polynomial!
]style[(10 63 9 2 10 16)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 polynomial;;,f1! !

!AlgebraicNumber methodsFor: 'arithmetic'!
* anObject
		"Public - gives a new algebraic number which is the product of myself and anAlgebraicNumber. For examples see the category examples in class"
	| x y poly inter |
	anObject isNumber 
		ifTrue: [anObject isNull
			ifTrue: [0]
			ifFalse: [
				anObject isAlgebraic
					ifTrue:[
						x _ RaisedVariable name: #x.
						y _ RaisedVariable name: #y.
						poly _ ((self polynomialAt: x/y)*(y raisedToInteger: self polynomial deg) resultant: (anObject polynomialAt: y) in: y) squareFree.
						[inter _ ClosedInterval
							center: ( self interval center * anObject interval center)
							delta: (self interval right abs * anObject aproximationError + (anObject interval left abs * self aproximationError)).
						(poly rootsIn: inter) = 1] whileFalse: [
							self refine.
							anObject refine].
						^ self class polynomial: poly * poly denominator interval: inter]]].
	^ (anObject adaptAlgebraicNumber: self) * (anObject adaptToAlgebraicNumber)! !

!AlgebraicNumber methodsFor: 'arithmetic'!
+ anObject
	"Public - gives a new algebraic number which is the sum of myself and anAlgebraicNumber. For examples see the category examples in class."
	| x y poly inter |
	^ anObject isNumber 
		ifTrue: [anObject isAlgebraic
			ifTrue:[
				x _ RaisedVariable name: #x.
				y _ RaisedVariable name: #y.
				poly _ ((self polynomialAt: x-y) resultant: (anObject polynomialAt: y) in: y) squareFree.
				[inter _ ClosedInterval new
					left: self left+anObject left;
					right: self right+anObject right.
					(poly rootsIn: inter) = 1] whileFalse: [
						self refine.
						anObject refine].
				self class polynomial: poly interval: inter]
			ifFalse: [
				self class new
					polynomial: (self polynomialAt: self polynomial variable asMonomial - anObject);
					interval: self interval + anObject]]
		ifFalse: [(anObject adaptAlgebraicNumber: self) + (anObject adaptToAlgebraicNumber)]
	! !

!AlgebraicNumber methodsFor: 'arithmetic' stamp: 'r++ y ary 5/2/98 02:12'!
- anAlgebraicNumber
	"Public - gives a new algebraic number which is the diference between myself and anAlgebraicNumber"
	^ self + (anAlgebraicNumber negated)! !

!AlgebraicNumber methodsFor: 'arithmetic' stamp: 'r++ y ary 5/2/98 02:11'!
/ anAlgebraicNumber
	"Public - gives a new algebraic number which is the division of myself and anAlgebraicNumber"
	^ self * (anAlgebraicNumber reciprocal)	! !

!AlgebraicNumber methodsFor: 'arithmetic'!
negated
	"Public - gives my aditive inverse. For example:  Raiz de 2  negated"
	^ self class new polynomial: (self polynomial valueAt: self polynomial variable * -1) asSimplePolynomial;
	 interval: self interval negated!
]style[(7 51 10 2 7 142)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 negated;;,f1! !

!AlgebraicNumber methodsFor: 'arithmetic' stamp: 'ary 5/10/98 13:42'!
reciprocal
	"Public - gives my inverse as algebraic number. For examples see the category examples in class."
	| left right |
	(self isNull) ifTrue: [ ^ self error: 'el cero no tiene inverso'].
	self interval left isNull
		ifTrue: [ left _ -1]
		ifFalse: [ left _ self interval left].
	self interval right isNull
		ifTrue: [right _ 1]
		ifFalse: [ right _ self interval right].
	^ self class
		polynomial: (self polynomial reverse)
		interval: (ClosedInterval left: right reciprocal right: left reciprocal).
! !

!AlgebraicNumber methodsFor: 'comparing'!
< anObject
	"Public - determines if I'm < anObject. For example:  Raiz de 2  <  Raiz de 3 "
	| value |
	^ anObject isNumber 
		ifTrue: [anObject isAlgebraic
			ifTrue:[ "Algebraic Number"
				(self interval intersects: anObject interval)
					ifFalse: ["Disjoint intervals" 
						self right < anObject left]
					ifTrue: ["Intersecting intervals"
						self refine.
						anObject refine.
						self < anObject]]
			ifFalse: ["non Algebraic Number"
				(self right < anObject) or: [(anObject > self left) and: [
						((value _ self polynomialAt: anObject) isNull not) and: [
							value sign = self polynomialAtRight sign]]]]]
		ifFalse: [(anObject adaptAlgebraicNumber: self) < (anObject adaptToAlgebraicNumber)]
!
]style[(10 56 9 2 1 2 9 628)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 < (AlgebraicNumber sqrtOf: 5);;,f1,f1PAlgebraicNumber sqrtOf: 3;;,f1! !

!AlgebraicNumber methodsFor: 'comparing' stamp: 'ary 5/10/98 14:06'!
<= aNumber
	"Public - determines if I'm <= aNumber "
	^ self < aNumber or: [self = aNumber]! !

!AlgebraicNumber methodsFor: 'comparing'!
= anAlgebraicNumber

	"Public - determines if i'm equal to anAlgebraicNumber. For example:  Raiz de 2   =   Raiz de 3 "
	| temp |
	^ anAlgebraicNumber isAlgebraic
		ifTrue:[
			temp _ self polynomial gcd: (anAlgebraicNumber polynomial).
			((Sturn new polynomial: temp) sturnIn: (anAlgebraicNumber interval)) = 1]
		ifFalse: [(anAlgebraicNumber adaptAlgebraicNumber: self) = (anAlgebraicNumber adaptToAlgebraicNumber)]
!
]style[(19 73 9 2 2 3 9 302)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 = (AlgebraicNumber sqrtOf: 3);;,f1,f1PAlgebraicNumber sqrtOf: 3;;,f1! !

!AlgebraicNumber methodsFor: 'comparing' stamp: 'ary 5/10/98 14:06'!
> aNumber
	"Public - determines if I'm > anumber "
	^ (self <= aNumber) not! !

!AlgebraicNumber methodsFor: 'comparing' stamp: 'ary 5/10/98 14:06'!
>= aNumber
	"Public - answer if I'm >= aNumber "
	^ (self < aNumber) not! !

!AlgebraicNumber methodsFor: 'comparing' stamp: 'ary 5/10/98 14:07'!
~= aNumber
	"Public - says if I'm not aNumber "
	^ (self = aNumber) not! !

!AlgebraicNumber methodsFor: 'testing' stamp: 'ary 5/10/98 14:07'!
isAlgebraic
	"Public - says if I'm algebraic "
	^ true! !

!AlgebraicNumber methodsFor: 'testing' stamp: 'ary 5/10/98 13:43'!
isNull
	"Public - answer if i'm the cero algebraic number. For example:  Raiz de 2   isNull "
	(self interval includes: 0) ifFalse: [^ false]
		 ifTrue: [ (self polynomial valueAt: 0) isNull
			ifTrue: [ ^ true]].
	^ false		!
]style[(6 67 9 3 6 133)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 isNull;;,f1! !

!AlgebraicNumber methodsFor: 'testing' stamp: 'ary 5/10/98 14:07'!
isNumber
	"Public - says if I'm a number "
	^ true! !

!AlgebraicNumber methodsFor: 'refining' stamp: 'ary 5/10/98 14:09'!
aproximationError
	" public - answer the error for printing me. For example:  Raiz de 2  aproximationError "	
	^ (self right - self left) / 2
!
]style[(18 60 9 2 17 3 1 32)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 aproximationError;;,f1,f1b,f1! !

!AlgebraicNumber methodsFor: 'refining' stamp: 'r++ 6/14/1998 20:02'!
aproximationError: aNumber
	"public - I will refine my interval so my printString represents
	me with an error smaller that aNumber"
	| m |
	[ self aproximationError > aNumber] whileTrue: [
		self polynomialAtLeft sign = ( m _ self polynomialAtMiddle) sign
			ifTrue: [self left: self center]
			ifFalse: [
				m isNull
					ifTrue: [
						self left: (m _ self center).
						self right: m]
					ifFalse: [self right: self center]].
		self updateMorph]! !

!AlgebraicNumber methodsFor: 'refining' stamp: 'ary 5/10/98 14:10'!
refine
	" public - reduce aproximationError to half. For example:  Raiz de 2  refine"
	self aproximationError: self aproximationError / 2!
]style[(6 60 10 2 6 53)f1b,f1,f1PAlgebraicNumber sqrt2;;,f1,f1PAlgebraicNumber sqrt2 refine;;,f1! !

!AlgebraicNumber methodsFor: 'printing'!
printOn: aStream
	"self polynomial printOn: aStream.
	aStream cr.
	self interval printOn: aStream.
	aStream cr."
	self interval center asFloat printOn: aStream.! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 6/14/1998 20:03'!
center
	" private - answers value in middle of my interval"
	^ self interval center! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 5/3/98 21:42'!
hasRootsAtLeftOf: aNumber
	" public - answer wheather my polynomial has a root inside my interval,
	but at left of aNumber"
	^ (self polynomialAt: self left) sign*(self polynomialAt: aNumber) sign <= 0! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 5/3/98 21:42'!
hasRootsAtRightOf: aNumber
	" public - answer wheather my polynomial has a root inside my interval,
	but at right of aNumber"
	^ (self polynomialAt: self right) sign*(self polynomialAt: aNumber) sign <= 0! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ y ary 5/1/98 16:16'!
interval: anInterval
	"Private - assigns the value to the instance variable "
	interval _ anInterval! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 02:16'!
left
	" private - answers value nearer negative infinity in my interval"
	^ self interval left! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 02:16'!
left: aNumber
	" private - set the value nearer negative infinity in my interval"
	self interval left: aNumber! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ y ary 5/1/98 16:16'!
polynomial: aPolynomial
	"Private - assigns the value to the instance variable "
	polynomial _ aPolynomial! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 01:53'!
polynomialAt: anObject
	" private - evaluate my polynomial at my left"
	^ self polynomial valueAt: anObject! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 01:53'!
polynomialAtLeft
	" private - evaluate my polynomial at my left"
	^ self polynomialAt: self left! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 6/14/1998 20:02'!
polynomialAtMiddle
	" private - evaluate my polynomial at my left"
	^ self polynomialAt: self center! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 01:54'!
polynomialAtRight
	" private - evaluate my polynomial at my left"
	^ self polynomialAt: self right! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 02:17'!
right
	" private - answers value nearer positive infinity in my interval"
	^ self interval right! !

!AlgebraicNumber methodsFor: 'private' stamp: 'r++ 4/30/98 02:17'!
right: aNumber
	" private - set the value nearer positive infinity in my interval"
	self interval right: aNumber! !

!AlgebraicNumber methodsFor: 'converting'!
adaptInteger: anInteger
	"Public - converts an integer so it can be added with an algebraic number "
	^ self class fromNumber: anInteger! !

!AlgebraicNumber methodsFor: 'converting'!
adaptToInteger
	" Private  adapts me so I can make arithmethic operations with an integer"
	^ self! !

!AlgebraicNumber methodsFor: 'converting' stamp: 'ari y r++ 7/2/1998 13:08'!
asAlgebraicNumber
	^ self! !

!AlgebraicNumber methodsFor: 'converting'!
asFloat
	^ (self aproximationError: (10 raisedToInteger: ((1.0/3) asString size - 2) negated)) center asFloat! !

!AlgebraicNumber methodsFor: 'converting' stamp: 'r++ 6/14/1998 20:02'!
asFraction
	^ self center asFraction! !


!OpenedInterval commentStamp: '<historical>' prior: 0!
My instances are mathematical Opened Intervals, they know how to intersect each other and if a point is included or not in them. They also know the result of intersecting each other, how to be translated, its center and to be negated.

	To create one use:
		OpenedInterval left: -6 right: -1/2
		OpenedInterval center: 5 delta: 2.2

	I have one subclass: ClosedInterval, to create SemiClosedInterval or SemiOpenedInterval you just need to override #printOn: and #includes:!
]style[(65 9 30 8 36 22 23 10 6 6 11 7 1 2 20 1 1 35 1 1 1 38 21 14 1 78 9 5 10)f1,f1LOpenedInterval intersects:;,f1,f1LOpenedInterval includes:;,f1,f1LOpenedInterval intersectionWith:;,f1,f1LOpenedInterval +;,f1,f1LOpenedInterval center;,f1,f1LOpenedInterval negated;,f1,f1LOpenedInterval negated;,f1,f1POpenedInterval center: 5 delta: 2.2;;,f1,f1POpenedInterval left: -6 right: -1/2;;,f1,f1POpenedInterval center: 5 delta: 2.2;;,f1,f1POpenedInterval center: 5 delta: 2.2;;,f1,f1LClosedInterval Comment;,f1POpenedInterval center: 5 delta: 2.2;;,f1,f1LOpenedInterval printOn:. ClosedInterval printOn:. OpenedInterval includes:. ClosedInterval includes:;,f1,f1LOpenedInterval printOn:. ClosedInterval printOn:. OpenedInterval includes:. ClosedInterval includes:;!

!OpenedInterval methodsFor: 'accessing' stamp: 'r++ 6/12/1998 14:23'!
left
	^left! !

!OpenedInterval methodsFor: 'accessing' stamp: 'r++ 6/12/1998 14:24'!
left: anObject
	left _ anObject! !

!OpenedInterval methodsFor: 'accessing' stamp: 'r++ 6/18/1998 19:43'!
length
	" public - answer my length"
	^ right - left! !

!OpenedInterval methodsFor: 'accessing' stamp: 'r++ 6/12/1998 14:24'!
right
	^right! !

!OpenedInterval methodsFor: 'accessing' stamp: 'r++ 6/12/1998 14:24'!
right: anObject
	right _ anObject! !

!OpenedInterval methodsFor: 'arithmetic' stamp: 'r++ 6/12/1998 14:36'!
+ aNumber
	" public - answer an interval which is my translation by aNumber.
	It's not necesary to changed this if implementing another kind of Intervals"

	^ self class left: self left+aNumber right: self right + aNumber! !

!OpenedInterval methodsFor: 'arithmetic' stamp: 'r++ 6/12/1998 14:37'!
center
	" public - answer my center.
	It's not necesary to changed this if implementing another kind of Intervals"

	^ self left + self right / 2! !

!OpenedInterval methodsFor: 'arithmetic' stamp: 'r++ 6/12/1998 14:37'!
intersectionWith: anInterval
	" public - answer the intersection between myself and anInterval, nil if it's empty
	It's not necesary to changed this if implementing another kind of Intervals"

	^ (self intersects: anInterval)
		ifFalse: []
		ifTrue: [
			self class
				left: (self left max: anInterval left)
				right: (self right min: anInterval right)]! !

!OpenedInterval methodsFor: 'arithmetic' stamp: 'r++ 6/12/1998 14:37'!
negated
	" public - answer anInterval that is simetrical to me respecting 0
	I's not necesary to changed this if implementing another kind of Intervals"

	^ self class new
		left: self right negated;
		right: self left negated.! !

!OpenedInterval methodsFor: 'testing' stamp: 'r++ 6/12/1998 14:50'!
includes: aNumber
	"public - answer if I include aNumber.
	This should be changed if implementing another kind of Intervals, as OpenInterval"
	^ (self left < aNumber) and: [self right > aNumber]! !

!OpenedInterval methodsFor: 'testing' stamp: 'r++ 6/12/1998 14:36'!
intersects: anInterval
	" public - answer wheader I intersect anInterval.
	It's not necesary to changed this if implementing another kind of Intervals"

	^ ((self right > anInterval left) and: [self left < anInterval right]) or: [
		(anInterval includes: self left) or: [anInterval includes: self right]]! !

!OpenedInterval methodsFor: 'printing' stamp: 'r++ 6/12/1998 14:29'!
printOn: aStream
	aStream nextPut: $(.
	self left printOn: aStream.
	aStream nextPut: $,.
	self right printOn: aStream.
	aStream nextPut: $).

! !


!ClosedInterval commentStamp: '<historical>' prior: 0!
My instances are mathematical Closed Intervals, they know everithing that OpenedIntervals know!
]style[(74 14 6)f1,f1LOpenedInterval Comment;,f1!

!ClosedInterval methodsFor: 'printing' stamp: 'r++ 6/12/1998 14:31'!
printOn: aStream
	aStream nextPut: $[.
	self left printOn: aStream.
	aStream nextPut: $,.
	self right printOn: aStream.
	aStream nextPut: $].

! !

!ClosedInterval methodsFor: 'testing' stamp: 'r++ 6/12/1998 14:31'!
includes: aNumber
	"public - answer if I include aNumber."

	^ (super includes: aNumber) or: [self left = aNumber or: [self right = aNumber]]! !


!OpenedInterval class methodsFor: 'instance creation' stamp: 'r++ 6/12/1998 14:26'!
center: center delta: delta
	" public - answer a new interval with center in middle and length delta*2.
		ClosedInterval center: 100 delta: 22:"
	^ self left: center - delta right: center+delta!
]style[(28 78 37 50)f1b,f1,f1PClosedInterval center: 100 delta: 22;;,f1! !

!OpenedInterval class methodsFor: 'instance creation' stamp: 'r++ 6/12/1998 14:27'!
left: aNumber right: bNumber
	^ self new
		left: aNumber;
		right: bNumber.! !


!ClosedInterval class reorganize!
('as yet unclassified')
!


!Polynomial commentStamp: '<historical>' prior: 0!
A polynomial is stored as a sorted collection of monomials with the lexicographic order. There are a lot of different ways of creating a polynomial. At first you have to define the variables which will be included in the polynomial. For example:
|x y|
x _ RaisedVariable name: #x .
y _ RaisedVariable name: #y.
x*x*y + (2*x) + y

Once the Polynomial is defined, there are a lot of things one would like to ask him (variables,  degIn: x, degIn: y, derivativeIn: x, derivativeIn: y, head, lc, value: x at: 3, isNull. You can play with a lot of other examples and functions between two polynomials in Morphic Word.
!
]style[(246 83 86 9 3 8 2 8 2 15 2 15 2 4 2 2 2 14 2 6 99)f1,f1PPolynomial example1;;,f1,f1PPolynomial example1 variables;;,f1,f1PPolynomial example1 degIn: (RaisedVariable name: #x);;,f1,f1PPolynomial example1 degIn: (RaisedVariable name: #y);;,f1,f1PPolynomial example1 derivativeIn: (RaisedVariable name: #x);;,f1,f1PPolynomial example1 derivativeIn: (RaisedVariable name: #y);;,f1,f1PPolynomial example1 head;;,f1,f1PPolynomial example1 lc;;,f1,f1PPolynomial example1 value: (Variable name: #x) at: 3;;,f1,f1PPolynomial example1 isNull;;,f1!

!Polynomial methodsFor: 'initialization'!
initializeMonomials
	"Private - initialize the instance variable"
	self monomials: (SortedCollection sortBlock: (Smalltalk at: #Monomial) sortBlock)! !

!Polynomial methodsFor: 'arithmetic'!
* anObject
	"Public - answer the result of multiplying me with anObject. For example:
	(y + 2*x + y*x^2) * (2*y + x) =
	For other examples you can play in Morphic Word"
	| answer |
	^ anObject isPolynomial
		ifTrue: [
			answer _ self class new.
			self monomialsDo: [:eachMyMon |
				anObject monomialsDo: [:eachHisMon |
					answer sum: eachMyMon * eachHisMon]].
			answer]
		ifFalse: [(anObject adaptPolynomial: self)*(anObject adaptToPolynomial)]
!
]style[(10 77 31 333)f1b,f1,f1PPolynomial example1 * Polynomial example2;;,f1! !

!Polynomial methodsFor: 'arithmetic'!
+ anObject
	" public - answer the result of adding anObject to me.
	For example: (y + 2*x + y*x^2) + (2*y + x) ="
	| answer |
	self isNull ifTrue: [^ anObject].
	anObject isNull ifTrue: [^ self].
	^ anObject isPolynomial
		ifTrue: [
			answer _ self copy.
			anObject monomialsDo: [:eachMonomial | answer sum: eachMonomial].
			answer]
		ifFalse: [(anObject adaptPolynomial: self)+(anObject adaptToPolynomial)] !
]style[(10 70 32 108 1 190)f1b,f1,f1PPolynomial example1 + Polynomial example2;;,f1,f1b,f1! !

!Polynomial methodsFor: 'arithmetic' stamp: 'ary 5/10/98 20:14'!
- aPolynomial 
	"Public - gives the sustraction between me and aPolynomial"
	^ self + aPolynomial negated! !

!Polynomial methodsFor: 'arithmetic'!
// aPolynomial
	" public - answer a Polynomial that represents the quotient of myself /
	 aPolynomial. (it will work only in an euclidean domain).
	For example: (y + 2*x + y*x^2) // (x + 1) = "
	^ (self dividedBy: aPolynomial in: (self variableWith: aPolynomial)) at: 1!
]style[(14 147 30 78)f1b,f1,f1PPolynomial example1 // Polynomial example3;;,f1! !

!Polynomial methodsFor: 'arithmetic'!
\\ aPolynomial 
	" public - answer a Polynomial that represents the remainder of myself / aPolynomial. (it will work only in an euclidean domain).
	For example: (y + 2*x + y*x^2) \\ (x + 1) = "
	^ (self dividedBy: aPolynomial in: self variable) at: 2!
]style[(161 30 59)f1,f1PPolynomial example1 \\ Polynomial example3;;,f1! !

!Polynomial methodsFor: 'arithmetic' stamp: 'r++ 6/18/1998 17:10'!
dividedBy: aPolynomial in: aVariable
	" public - answer myself divided by a Polynomial expressed as polynomials in aVariable"
	| r g q factor var |
	r _ self asPolynomialIn: aVariable.
	g _ aPolynomial asPolynomial asPolynomialIn: aVariable.
	"g isMonic ifFalse: [self error: 'only divsion by monical polynomials allowed']."
	q _ Polynomial new.
	var _ aVariable copy.
	[r deg < g deg or: [r isNull]] whileFalse: [
		factor _ ((var deg: r deg - g deg) * r lc * g lc reciprocal) asPolynomialIn: aVariable.
		q _ q + factor.
		r _ r - (g*factor)].
	^ Array with: q with: r! !

!Polynomial methodsFor: 'arithmetic' stamp: 'r++ 6/18/1998 17:10'!
negated
	"Public - gives my aditive inverse "
	^ self collect: [:eachMonomial | eachMonomial negated]! !

!Polynomial methodsFor: 'arithmetic' stamp: 'ary 5/10/98 20:16'!
privateAdd: aPolynomialOrNumber
	"Private - it's an internal way of adding two polynomials"
	| aPolynomial |
	aPolynomial _ (aPolynomialOrNumber isKindOf: Number)
				ifTrue: [Monomial fromNumber: aPolynomialOrNumber]
				ifFalse: [aPolynomialOrNumber].
	aPolynomial monomialsDo: [:eachMonomial | self sum: eachMonomial].
! !

!Polynomial methodsFor: 'arithmetic' stamp: 'r++ 5/3/98 18:18'!
quo: anObject
	" needed for compatibility with SmallInteger //"
	^ self // anObject! !

!Polynomial methodsFor: 'arithmetic' stamp: 'r++ 6/18/1998 19:20'!
raisedToInteger: anInteger
	"Public - gives the answer of multiplying me anInteger times"
	
|mid|

	
anInteger < 0 ifTrue: [^(self raisedToInteger: anInteger negated) reciprocal].
	
anInteger = 0 ifTrue: [^1].
	
anInteger = 1 ifTrue: [^self].
	
mid _ anInteger // 2.
	
^ (self raisedToInteger: (anInteger - mid)) * (self raisedToInteger: mid)! !

!Polynomial methodsFor: 'arithmetic' stamp: 'ary 5/10/98 21:25'!
squared
	"Public - answer my squared"
	^ self * self! !

!Polynomial methodsFor: 'accesing' stamp: 'r++ 12/18/96 20:29'!
add: aMonomial
	" add myself a Monomial "
	aMonomial coef isNull not ifTrue: [self monomials add: aMonomial]! !

!Polynomial methodsFor: 'accesing' stamp: 'r++ 6/17/1998 13:10'!
coefAt: aMonicMonomial 
	" answers the coeficient which multiplies aMonicMonomial in self, or null if 
	aMonicMonomial is not present"
	^ (self monomialAt: aMonicMonomial ifNone: [self nullMonomial]) coef! !

!Polynomial methodsFor: 'accesing' stamp: 'ary 5/10/98 20:25'!
coefAt: aMonomial put: aCoeficient
	"Private - sets the coeficient which multiplies aMonomial "
	self remove: aMonomial.
	aCoeficient isNull ifFalse: [self add: (aMonomial copy coef: aCoeficient)]! !

!Polynomial methodsFor: 'accesing' stamp: 'r++ 6/18/1998 15:08'!
remove: aMonicMonomial 
	" public - removes Monomial that matches aMonicMonomial"
	self monomials remove: (self monomialAt: aMonicMonomial ifNone: [nil]) ifAbsent: [nil]! !

!Polynomial methodsFor: 'accesing'!
variable
	" public - answer my first variable. if I'm a one variable polynomial, it's my only variable"
	^ self variables isEmpty
		ifTrue: [RaisedVariable new]
		ifFalse: [self variables last copy deg: 1]! !

!Polynomial methodsFor: 'accesing' stamp: 'r++ 5/3/98 18:31'!
variableWith: aPolynomial
	" public - answer my variable. If it's none, answer aPolynomial's variable"
	^ self variables isEmpty
		ifTrue: [aPolynomial variable]
		ifFalse: [self variable]! !

!Polynomial methodsFor: 'accesing'!
variables
	" public - answer a SortedCollection filled up with all my variables"
	| answer |
	answer _ Set new.
	self monomialsDo: [:eachMon |
		answer addAll: (eachMon variables collect: [:eachVar |
			eachVar copy deg: 1])].
	^ answer
		asSortedCollection: (answer detect: [:one | one isNil not] ifNone: [RaisedVariable new]) class sortBlock! !

!Polynomial methodsFor: 'converting' stamp: 'ary 5/10/98 16:15'!
, anObject
	"Public - answer a Tuple with myself and anObject"
	^ (Tuple new add: self ; add: anObject)! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 6/18/1998 17:27'!
adaptFraction: aFraction
	^ aFraction asPolynomial! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 12/18/96 19:48'!
adaptInteger: anInteger
	^ anInteger asPolynomial! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 5/3/98 14:04'!
adaptMonicMonomial: aMonicMonomial
	^ aMonicMonomial asPolynomial! !

!Polynomial methodsFor: 'converting'!
adaptMonomial: aMonomial
	^ self class new add: aMonomial ! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 6/18/1998 17:28'!
adaptToFraction
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 12/18/96 19:49'!
adaptToInteger
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 5/3/98 14:04'!
adaptToMonicMonomial
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 4/25/98 17:33'!
adaptToMonomial
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 4/25/98 18:00'!
adaptToVariable
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 4/25/98 18:00'!
adaptVariable: aVariable
	^ aVariable asPolynomial! !

!Polynomial methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 16:48'!
asPolynomial
	^ self! !

!Polynomial methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 16:47'!
asPolynomialIn: aVariable 
	" public - answer my degree"
	^ self asSimplePolynomial asPolynomial collect: [:eachMon | eachMon asMonomialIn: aVariable]
! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 4/25/98 18:10'!
asSimplePolynomial
	^ self collect: [:eachMon | eachMon asSimplePolynomial]! !

!Polynomial methodsFor: 'converting' stamp: 'r++ 6/18/1998 19:01'!
asTuple
	" public - answer my coeficints as a Tuple.
	Usefull for filling up a Matrix with my coeficients"
	| answer var |
	answer _ (Smalltalk at: #Tuple) new.
	var _ self variable copy.
	0 to: self deg do: [:each |
		answer add: (self coefAt: (var deg: each) asMonicMonomial) asSimplePolynomial].
	^ answer! !

!Polynomial methodsFor: 'converting'!
asTupleIn: aVariable
	" public - answer my coeficints as a Tuple.
	Usefull for filling up a Matrix with my coeficients"
	^ (self asPolynomialIn: aVariable) asTuple! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:27'!
deg
	" public - answer my degree. See ? for examples"
	^ self head deg! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:23'!
degIn: aVariable 
	" public - answer my degree in aVariable. For examples see ?"
	^ (self asPolynomialIn: aVariable) deg! !

!Polynomial methodsFor: 'polynomial functions'!
denominator
	"Public - gives the lcm for the denominators of the polinomyal if it's in a single variable"
	| answer |
	answer _ 1.
	self asSimplePolynomial monomialsDo: [ :each |
		each coef isFraction ifTrue: [
			answer _ answer lcm: each coef denominator]].
	^ answer! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 20:26'!
derivative
	" public - answer my derivative in my first variable. For examples see the ?"
	^ self derivativeIn: self variable! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:15'!
derivativeIn: aVariable 
	" public - answer my derivative computed at aVariable. For example: 
	 y^3*x*11 + y^2*2 + x^3*3 derivativeIn: x	"
	^ self collect: [:eachMon | eachMon derivativeIn: aVariable]!
]style[(23 73 41 64)f1b,f1,f1P| x y |
	x _ Monomial variable: 'x'.
	y _ Monomial variable: 'y'. 
	(y*y*y*x*11) + (y*y*2) + (x*x*x*3) derivativeIn: x;;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'r++ 6/17/1998 14:16'!
gcd: aPolynomial 
	" Public - answer the gcd betwen myself and a polynomial , both expressed in aVariable. For example:  (1 + x + x^2) gcd: ( 1 - x^2). See also  gcd: in: "
	^ (self gcd: aPolynomial in: self variable)!
]style[(16 104 30 11 9 47)f1b,f1,f1P|x|
x _ Variable name: #x .
(x*x + (2*x) + 1) gcd: ( x*x - 1);;,f1,f1LPolynomial gcd:in:;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:23'!
gcd: aPolynomial in: aVariable

	" Public - answer the gcd betwen myself and a polynomial , both expressed in aVariable. For example:  (x^3*y + 2*y + 3*y*x) gcd: (x*y + y) in: x"
	|r1 r2 aux|
	
r1 _ self asPolynomialIn: aVariable.
	r2 _ aPolynomial asPolynomialIn: aVariable.
	[r2 deg = 0] whileFalse: [
		aux _ r1 \\ r2.
		r1 _ r2.
		r2 _ aux].
	^ r2 isNull
		ifTrue: [r1]
		ifFalse: [1]!
]style[(30 105 42 211)f1b,f1,f1P|x y|
x _ Variable name: #x .
y _ Variable name: #y.
(x*x*y + (2*y) + (3*y*x)) gcd: (x*y + y) in: x;;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:11'!
head
	" public - answer my greater monomial. For an example see ?"
	^ self monomials isEmpty
		ifTrue: [self nullMonomial]
		ifFalse: [self monomials last]! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:11'!
lc
	" public - answer my leading coeficient. For an example see ?"
	^ self head coef asSimplePolynomial! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:11'!
monic
	" public - answer a monic polynomial that is my multiple. For example: (6 + 2*x + 3*x^2) monic"
	^ (self * self lc reciprocal) asSimplePolynomial!
]style[(5 73 23 51)f1b,f1,f1P|x|
x _ Variable name: #x .
(3*x*x + (2*x) + 6) monic;;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:09'!
nullMonomial
	"Public - answer a monomial that represents the correct monoial for zero
	that is with the coeficient of the apropiate class. null "
	^ 0 asMonomial
	!
]style[(12 128 4 20)f1b,f1,f1PPolynomial new nullMonomial;;,f1! !

!Polynomial methodsFor: 'polynomial functions'!
resultant: aPolynomial in: aVariable
	"Public - gives a new polynomial which is the resultant between me and aPolynomial in the variable aVariable . For example:
|x|
x _ RaisedVariable name: #x.
(x*x + (2*x) + 2) squared resultant: ((x*x + (2*x) + 2) squared derivative) in: x ="
	| pol1 pol2 matrix size1 size2 |
	pol1 _ (self asTupleIn: aVariable) reverse.
	pol2 _ (aPolynomial asTupleIn: aVariable) reverse.
	size1 _ (pol1 size - 1).
	size2 _ (pol2 size - 1).
	(size2 - 1) timesRepeat: [pol1 add: 0].
	(size1 - 1) timesRepeat: [pol2 add: 0].
	matrix _ Matrix new.
	size2 timesRepeat: [matrix addRow: pol1.
							pol1 _ pol1 shift].
	size1 timesRepeat: [matrix addRow: pol2.
							pol2 _ pol2 shift].
	^ (EuclideanMatrixReducer new matrix: matrix euclideanFunction: self class defaultEuclideanFunction) det!
]style[(36 126 116 532)f1b,f1,f1P|x|
x _ RaisedVariable name: #x.
(x*x + (2*x) + 2) squared resultant: ((x*x + (2*x) + 2) squared derivative) in: x;;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 20:43'!
reverse
	" public - answer a Polynomial with coeficient reversed.
	Usefull for computing the minimal polynomial of an algebraic number
	given it's reciprocal's minimal>For examples see reversedIn:"
	^ self reversedIn: self variable!
]style[(7 178 11 35)f1b,f1,f1LPolynomial reersedIn:;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 20:39'!
reversedIn: aVariable
	" public - answer a Polynomial with coeficient reversed.
	Usefull for computing the minimal polynomial of an algebraic number
	given it's reciprocal's minimal. For example:  (2*x + y + y*x^2) reversedIn: x"
	| deg |
	deg _ self degIn: aVariable.
	^ (self asPolynomialIn: aVariable) collect: [:eachMon |
		eachMon copy at: aVariable put: deg - eachMon deg]	!
]style[(21 176 31 151)f1b,f1,f1P|x y|
x _ Variable name: #x .
y _ Variable name: #y.
(x*x*y + (2*x) + y) reversedIn: x;;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 21:13'!
rootsFrom: aNumber to: anotherNumber

	"Public - gives the number of roots between aNumber an anotherNumber using the Sturn algorithm. For example see:  rootsIn:"
	^(Sturn new polynomial: self) sturnIn: (ClosedInterval left: aNumber right: anotherNumber)
!
]style[(36 117 8 94)f1b,f1,f1LPolynomial rootsIn:;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'r++ 6/18/1998 20:02'!
rootsIn: anInterval
	"Public - gives the number of roots between aNumber an anotherNumber using the Sturn algorithm. For examples see  sturn"
	^ anInterval length = 0
		ifTrue: [(self valueAt: anInterval left) = 0 ifTrue: [1] ifFalse: [0]]
		ifFalse: [(Sturn new polynomial: self) sturnIn: anInterval]
!
]style[(19 116 5 162)f1b,f1,f1L;,f1! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'r++ 6/17/1998 14:15'!
squareFree
	" public - answer a monic polynomial with the same roots as me, but with order 1
	 (x+1)*(x+1) squareFree
	"
	| r1 r2 |
	r1 _ self monic.
	r2 _ r1 derivative.
	^ (r1 // (r1 gcd: r2)).
!
]style[(10 83 1 23 79)f1b,f1,f1d	| x |
	x _ Variable name: #x.
	((x+1)*(x+1)) squareFree;;,f1P| x |
	x _ Variable name: #x.
	((x+1)*(x+1)) squareFree;;,f1! !

!Polynomial methodsFor: 'polynomial functions'!
value: aVariable at: anObject
	" public - evaluates myself when aVariable is anObject. For examples see ?"
	^ self collect: [:eachMon | eachMon value: aVariable at: anObject]! !

!Polynomial methodsFor: 'polynomial functions' stamp: 'ary 5/10/98 20:42'!
valueAt: anObject
	"Public - evaluates my first variable at anObject. For examples see ? "
	^ self value: self variable at: anObject! !

!Polynomial methodsFor: 'testing' stamp: 'ary 5/10/98 20:31'!
= aPolynomial
	"Public - determines if I'm equal to aPolynomial "
	^ (self - aPolynomial) asSimplePolynomial isNull! !

!Polynomial methodsFor: 'testing' stamp: 'ary 5/10/98 20:32'!
isMonic
	"Public - answer if I'm monis "
	^ self head isMonic! !

!Polynomial methodsFor: 'testing' stamp: 'ary 5/10/98 20:33'!
isNull
	"Public - answer if I'm the null polynomial "
	self monomialsDo: [:eachMonomial | eachMonomial isNull ifFalse: [^ false]].
	^ true! !

!Polynomial methodsFor: 'testing' stamp: 'ary 5/10/98 20:33'!
isPolynomial
	"Public - answer if I'm a polynomial "
	^ true! !

!Polynomial methodsFor: 'testing' stamp: 'r++ 4/25/98 18:44'!
negative
	^ false! !

!Polynomial methodsFor: 'enumerating' stamp: 'r++ 4/25/98 18:12'!
collect: aBlock 
	" public - creates a new polynomial after collecting for monomials"
	| answer |
	answer _ 0.
	self monomialsDo: [:eachMon | answer _ answer + (aBlock value: eachMon)].
	^ answer! !

!Polynomial methodsFor: 'enumerating'!
monomialsDo: aBlock
	"Public - evaluates aBlock in each monomial "
	self monomials reversed do: aBlock! !

!Polynomial methodsFor: 'printing'!
printOn: aStream 
	| first |
	self isNull
		ifTrue: [0 printOn: aStream]
		ifFalse: [
			first _ true.
			aStream nextPut: $(.
			self
				monomialsDo: 
					[:eachMonomial | 
					first
						ifTrue: [first _ false]
						ifFalse: [aStream nextPutAll: ' + '].
					eachMonomial printOn: aStream].
			aStream nextPut: $)]! !

!Polynomial methodsFor: 'private'!
monomialAt: aMonomial ifNone: exceptionBlock 
	" private - answers the monomial whos variables matches aMonicMonomial's
	if none value axceptionBlock"
	| index |
	index _ self monomials findFirst: [:eachMon |
		aMonomial variables = eachMon variables].
	^ index ~= 0
		ifTrue: [ self monomials at: index]
		ifFalse: [ exceptionBlock value]! !

!Polynomial methodsFor: 'private'!
monomials
	monomials ifNil: [self initializeMonomials].
	^ monomials! !

!Polynomial methodsFor: 'private'!
monomials: aCollectionOfMonomials
	monomials _ aCollectionOfMonomials! !

!Polynomial methodsFor: 'private' stamp: 'r++ 6/18/1998 16:53'!
sum: aMonomial 
	| c |
	c _ (self coefAt: aMonomial)
				+ aMonomial coef.
	self coefAt: aMonomial put: c! !

!Polynomial methodsFor: 'copying' stamp: 'ary 5/10/98 20:30'!
copy
	"Private - creates a copy of myself"
	^ self class new monomials: self monomials copy! !


!Polynomial class methodsFor: 'instance creation' stamp: 'r++ 5/3/98 14:05'!
fromMonicMonomial: aMonicMonomial
	^ Polynomial new add: aMonicMonomial asMonomial! !

!Polynomial class methodsFor: 'instance creation' stamp: 'r++ y ary 5/2/98 02:31'!
fromMonomial: aMonomial
	^ Polynomial new add: aMonomial! !

!Polynomial class methodsFor: 'instance creation' stamp: 'r++ 12/18/96 16:39'!
fromNumber: aNumber
	" public - answer a Polynomial that represents a Number"
	^ self new add: aNumber asMonomial! !

!Polynomial class methodsFor: 'instance creation' stamp: 'r++ 12/18/96 16:42'!
with: aMonomial
	" public - answer a Polynomial with a monomial"
	^ self new add: aMonomial! !

!Polynomial class methodsFor: 'instance creation'!
with: aMonomial with: anotherMonomial
	" public - answer a Polynomial with two monomials"
	^ self new add: aMonomial; add: anotherMonomial! !

!Polynomial class methodsFor: 'examples'!
example1
	|x y|
	x _ RaisedVariable name: #x .
	y _ RaisedVariable name: #y.
	^ x*x*y + (2*x) + y! !

!Polynomial class methodsFor: 'examples'!
example2
	|x y|
	x _ RaisedVariable name: #x .
	y _ RaisedVariable name: #y.
	^ x + (2*y)! !

!Polynomial class methodsFor: 'examples' stamp: 'ari y r++ 6/26/1998 06:12'!
example3
	|x|
	x _ RaisedVariable name: #x .
	^ x + 1! !

!Polynomial class methodsFor: 'defaults' stamp: 'r++ 5/3/98 20:36'!
defaultEuclideanFunction
	^ [:a | a isNumber ifTrue: [0] ifFalse: [a deg]]! !

!Polynomial class methodsFor: 'defaults' stamp: 'r++ 12/18/96 18:11'!
defaultSortBlock
	^ [:a :b | b >= a]! !


!SortedCollection methodsFor: 'comparing'!
< aSortedCollection
	"ari y r++ 6/25/1998 00:23
		Answer true if I'm lexicografically smaller, using my sortBlock, than aSortedCollection."
	1 to: (self size min: aSortedCollection size) do: [:eachIndex |
		(self sortBlock value: (self at: eachIndex) value: (aSortedCollection at: eachIndex))
			ifTrue: [^true].
		(self sortBlock value: (aSortedCollection at: eachIndex) value: (self at: eachIndex))
			ifTrue: [^false]].
	^ self size < aSortedCollection size! !


!Sturn commentStamp: '<historical>' prior: 0!
My instances know how to compute the Sturn's sucesion, and counting sign changes calculates the number of roots in an interval (for doing that, I take the polynomial squareFreed). Then the number of roots is really the number of different roots in the interval. For example: (3 + x + 2*x^2 + x^3) sturnIn:  [-3,0].
	For more examples you can play in the Morphic Word.!
]style[(165 11 99 21 1 8 2 6 54)f1,f1LPolynomial squareFree;,f1,f1P| x |
x _ Variable name: #x.
x*x*x + (2*x*x)+x+3;;,f1,f1P|x|
x _ Variable name: #x.
(Sturn new polynomial: (x*x*x+(2*x*x)+x+3)) sturnIn: (ClosedInterval left: (-3) right: 0);;,f1,f1PClosedInterval left: (-3) right: 0;;,f1!

!Sturn methodsFor: 'initializing' stamp: 'ary 5/10/98 14:35'!
initializePolynomials
	"Private - initialize the method"
	self polynomials: OrderedCollection new! !

!Sturn methodsFor: 'accesing' stamp: 'r++ y ary 4/26/98 17:14'!
polynomials

	"Public - answer the current value of the instance variable"
	polynomials ifNil: [self initializePolynomials].
	^ polynomials! !

!Sturn methodsFor: 'accesing' stamp: 'r++ 6/19/1998 22:27'!
sturnIn: anInterval

	"Public - answer the number of roots of the polynomial in the interval [a,b]"
	| left right count last |
	self polynomials isNumber ifTrue: [ self polynomials isNull ifTrue: 										[self error: ' tiene infinitas raices']
									ifFalse: [^0]].
	left _ self polynomials collect: [:eachPol | eachPol valueAt: anInterval left].
	right _ self polynomials collect: [:eachPol | eachPol valueAt: anInterval right].
	count _ 0.
	last _ 0.
	left do: [:each |
		count _ count + ((each sign-last) abs // 2).
		(each sign = 0) ifFalse: [last _ each sign]].
	last _ 0.
	right do: [:each |
		count _ count - ((each sign-last) abs // 2).
		(each sign = 0) ifFalse: [last _ each sign]].
	^ count! !

!Sturn methodsFor: 'printing' stamp: 'ary 5/10/98 14:34'!
printOn: aStream
	self polynomials printOn: aStream
	! !

!Sturn methodsFor: 'private - accesing' stamp: 'r++ 6/19/1998 22:27'!
polynomial: aPolynomial

	"Private - redefines the instance variable"
	| r1 r2 aux |
	aPolynomial isNumber ifTrue: [^ self polynomials: aPolynomial].
	r1 _ aPolynomial squareFree.
	r2 _ r1 derivative.
	[r1 deg = 0] whileFalse: [
		self polynomials add: r1.
		aux _ (r1 \\ r2) negated.
		r1 _ r2.
		r2 _ aux].
	self polynomials add: r1.! !

!Sturn methodsFor: 'private - accesing' stamp: 'r++ y ary 4/26/98 17:13'!
polynomials: aCollection
	" private - instance variable polynomials is Sturn's sucession"
	polynomials _ aCollection! !


!Tuple commentStamp: '<historical>' prior: 0!
(Tuple fromString: '1 2 3 4 5') * (Tuple fromString: '1 2 0 0 5') =
!
]style[(31 3 31 1 1 1)f1P(Tuple fromString: '1 2 3 4 5');;,f1,f1P(Tuple fromString: '1 2 0 0 5');;,f1,f1P(Tuple fromString: '1 2 3 4 5') * (Tuple fromString: '1 2 0 0 5');;,f1!

!Tuple methodsFor: 'initialization'!
initializeElements
	"assign empty array to elements"
	self elements: OrderedCollection new.
! !

!Tuple methodsFor: 'arithmetic'!
* aTupleOrInteger
    "returns a new Tuple that is the myself * aTupleOrInteger"
    |answer|
    answer _ self copy.
    (aTupleOrInteger isKindOf: Tuple)
        ifTrue: [ self indexesDo: [:each | answer at: each put: ((self at: each) * (aTupleOrInteger at: each))]]
        ifFalse: [answer _self collect: [:each|each * aTupleOrInteger]].
    ^answer! !

!Tuple methodsFor: 'arithmetic'!
** aTuple
    "answers the inner product between me and aTuple"
	|answer|
	answer _ 0.
	self indexesDo: [:each | answer _ answer + ((self at: each) * (aTuple at: each))].
	^answer! !

!Tuple methodsFor: 'arithmetic' stamp: 'r++ 7/18/97 17:39'!
+ aTuple
    "returns a new Tuple that is the addition of self + aTuple"
    |ans|
    ans _ self class new.
    1 to: self size do: [:each | ans add: ((self at: each) + (aTuple at: each))].
    ^ans! !

!Tuple methodsFor: 'arithmetic'!
- aTuple
    "public - returns a new Tuple that is the addition of self + aTuple"
    ^ self + aTuple negated! !

!Tuple methodsFor: 'arithmetic'!
/ aNumber
    "returns a new Tuple that each of my elements / aNumber"
	^ self class new: (self elements collect: [:each|each / aNumber])
! !

!Tuple methodsFor: 'arithmetic'!
// aNumber
	"returns a new Tuple that each of my elements // aNumber"
	^ self class new: (self elements collect: [:each | each // aNumber])! !

!Tuple methodsFor: 'arithmetic' stamp: 'r++ 12/4/97 11:54'!
negated
    "public - returns a negated copy of the Tuple"
    |ans|
    ans _ self class newFrom: (self elements collect: [:anElement | anElement negated]).
    ^ ans! !

!Tuple methodsFor: 'arithmetic' stamp: 'r++ y ary 5/1/98 16:34'!
shift
	"Public - moves all of my elements one place to the right, losing the last one "
	| answer |
	answer _ self copy.
	2 to: (self size) do: [ :each | answer at: each put: (self at: (each - 1))].
	answer at: 1 put: 0.
	^ answer! !

!Tuple methodsFor: 'accessing'!
at: anIndex
        "returns value at index anIndex"
    ^self elements at: anIndex! !

!Tuple methodsFor: 'accessing'!
at: anIndex put: aValue
        "returns value at index anIndex"
    self elements at: anIndex put: aValue.
    ^self! !

!Tuple methodsFor: 'accessing'!
size
    "returns the number of elements of this Tuple"
  ^self elements size! !

!Tuple methodsFor: 'adding'!
add: anElement
    self elements add: anElement.
   ^self! !

!Tuple methodsFor: 'comparing'!
= aTuple
	1 to: self size do: [:eachIndex |
		(self at: eachIndex) = (aTuple at: eachIndex) ifFalse: [^false]].
	^true! !

!Tuple methodsFor: 'comparing' stamp: 'r++ y ary 5/3/98 16:02'!
isNull
	self elements do: [:eachElem | eachElem isNull ifFalse: [^ false]].
	^ true! !

!Tuple methodsFor: 'enumarating' stamp: 'r++ 12/4/97 11:54'!
collect: aBlock
    " public - answer a new Tuple with aBlock value: eachElement as elements"
	^ self class newFrom: (self elements collect: aBlock)! !

!Tuple methodsFor: 'enumarating'!
indexesDo: aBlock
    "values aBlock with indexes as values"
    1 to: self size do: [:each | aBlock  value: each].
    ^self! !

!Tuple methodsFor: 'copying' stamp: 'r++ y ary 5/1/98 18:21'!
, anElement
    "returns a new Tuple that is self appended with anElement"
   ^(self class newFrom: self elements) add: anElement.! !

!Tuple methodsFor: 'copying' stamp: 'r++ 12/4/97 11:54'!
copy
	^ self class newFrom: self elements copy! !

!Tuple methodsFor: 'copying' stamp: 'r++ 7/18/97 17:30'!
| aTuple
	^ Matrix new
		addRow: self;
		addRow: aTuple;
		yourself! !

!Tuple methodsFor: 'tuple functions' stamp: 'r++ y ary 5/1/98 16:51'!
reverse
	"Public - answer the reverse of me, that is me from end to the biggining " 
	| answer size |
	answer _ self copy.
	size _ self size + 1.
	self indexesDo: [ :each | answer at: each put: ( self at: (size - each))].
	^ answer! !

!Tuple methodsFor: 'tuple functions' stamp: 'r++ 6/12/1998 15:42'!
reversed
	"Public - answer a reversed copy of me, that is me from end to the biggining " 
	| answer size |
	answer _ self copy.
	size _ self size + 1.
	self indexesDo: [ :each | answer at: each put: ( self at: (size - each))].
	^ answer! !

!Tuple methodsFor: 'printing'!
printOn: aStream
    |isFirst|
    isFirst := true.
	1 to: self size do: [:eachIndex | 
    
        aStream nextPut: (isFirst
            ifTrue: [isFirst := false. $(]
            ifFalse: [$,]).
        (self at: eachIndex) printOn: aStream].
    aStream nextPut: $)! !

!Tuple methodsFor: 'private'!
elements
    "returns the elements of this Tuple"
	elements isNil ifTrue: [self initializeElements].
    ^elements! !

!Tuple methodsFor: 'private'!
elements: anArray
    "assigns to the elements of this Tuple"
    elements _ anArray.
    ^self! !

!Tuple methodsFor: 'morphic support'!
drawOn: aCanvas 
	aCanvas fillOval: self bounds color: self color! !


!Tuple class methodsFor: 'instance creation' stamp: 'ary 5/10/98 18:09'!
canonic: anInteger dim: bInteger
	"Public - answer a Tuple with all zeros except the anInteger place"
	^(Tuple zeros: bInteger) at: anInteger put: 1! !

!Tuple class methodsFor: 'instance creation' stamp: 'r++ 12/4/97 11:54'!
fromString: aString 
	"public - returns a new Tuple filled in with values from a String like 
	
 
	
    Tuple fromString: '(1 5 2 6 8)' or '1 5 7 4 2' or (1,4,6,4,3) or 5,7,4,3,6"
	^ self newFrom: ((aString findTokens: #($  $, $( $) $	 ))
			collect: [:each | Number readFrom: each])! !

!Tuple class methodsFor: 'instance creation' stamp: 'r++ 12/4/97 11:54'!
new: n
	self error! !

!Tuple class methodsFor: 'instance creation' stamp: 'r++ 12/4/97 11:54'!
newFrom: anObject
	^ (anObject isKindOf: String)
		ifTrue: [self fromString: anObject]
		ifFalse: [self new elements: anObject copy].
! !

!Tuple class methodsFor: 'instance creation' stamp: 'r++ 6/12/1998 15:08'!
zero: anInteger
	"Public - creates a tuple with anInteger zeros"
	| answer |
	answer _ Tuple new.
	anInteger timesRepeat: [ answer add: 0].
	^ answer! !


!Variable commentStamp: '<historical>' prior: 0!
My instances represent named variables.
Originally I'm planned to be superclass for smarter kind of variables, as RaisedVariables.
My instances have a name: (Variable name: #x) inspect and they know how to ve evaluated at an Object.
!
]style[(114 14 29 27 25 9 15)f1,f1L;,f1,f1d(Variable name: #x) inspect;;,f1,f1LVariable valueAt:. RaisedVariable valueAt:;,f1!

!Variable methodsFor: 'accessing'!
name
	" public - answer my name "
	^ name! !

!Variable methodsFor: 'accessing' stamp: 'r++ 5/11/98 02:59'!
name: aSymbol 
	" public - set my name"
	name _ aSymbol.! !

!Variable methodsFor: 'arithmetic'!
* anObject
	"public - to multiply a Variable by anything, all must be adaped"
	^ (anObject adaptVariable: self) * (anObject adaptToVariable)!
]style[(70 6 64)f1,f1LVariable adaptToVariable. Variable adaptVariable:;,f1! !

!Variable methodsFor: 'arithmetic'!
+ anObject
	"public - to add anything to a Variable, all must be adaped"
	^ (anObject adaptVariable: self) + (anObject adaptToVariable)!
]style[(65 6 64)f1,f1LVariable adaptToVariable. Variable adaptVariable:;,f1! !

!Variable methodsFor: 'arithmetic' stamp: 'r++ 5/3/98 18:51'!
- anObject
	^ self + anObject negated! !

!Variable methodsFor: 'arithmetic' stamp: 'r++ 5/3/98 15:46'!
/ anObject
	^ self * anObject reciprocal! !

!Variable methodsFor: 'arithmetic'!
// anObject
	"public - to divide a Variable by anything, all must be adaped"
	^ (anObject adaptVariable: self) // (anObject adaptToVariable)
!
]style[(69 6 66)f1,f1LVariable adaptToVariable. Variable adaptVariable:;,f1! !

!Variable methodsFor: 'arithmetic'!
\\ anObject
	"public - to divide a Variable by anything, all must be adaped"
	^ (anObject adaptVariable: self) \\ (anObject adaptToVariable)
!
]style[(69 6 66)f1,f1LVariable adaptToVariable. Variable adaptVariable:;,f1! !

!Variable methodsFor: 'arithmetic'!
negated
	"public - the only way to negate a Variable is multiplying it by -1 so it will be converted to a Monomial"
	^ self asMonomial negated! !

!Variable methodsFor: 'comparing'!
= aVariable
	^ (self class == aVariable class)
		and: [self name = aVariable name].! !

!Variable methodsFor: 'comparing' stamp: 'r++ 5/11/98 02:53'!
hash
	^ self name hash! !

!Variable methodsFor: 'comparing'!
isNull

	^ false! !

!Variable methodsFor: 'comparing'!
isVariable
	^ true! !

!Variable methodsFor: 'comparing'!
lexSmallerOrEqualThan: aVariable 
	"public - answer if my name is lexicografically smaller or equal than aVariable's."
	^ (self lexSmallerThan: aVariable) or: [ self = aVariable ].! !

!Variable methodsFor: 'comparing'!
lexSmallerThan: aVariable
	"public - answer if my name is lexicografically smaller than aVariable's."
	^ self name < aVariable name! !

!Variable methodsFor: 'comparing'!
sameAs: aVariable
	"public - answer if I'm reprecenting the same variable as aVariable.
	Variables are identified only by it's name"
	^ self name = aVariable name.! !

!Variable methodsFor: 'converting' stamp: 'ary 5/10/98 16:15'!
, anObject
	"Public - answer a Tuple with myself and anObject"
	^ (Tuple new add: self ; add: anObject)! !

!Variable methodsFor: 'converting' stamp: 'ari y r++ 6/26/1998 07:42'!
adaptAlgebraicNumber: aNumber
	^ Monomial fromNumber: aNumber! !

!Variable methodsFor: 'converting' stamp: 'r++ 6/18/1998 17:38'!
adaptFloat: aNumber
	^ Monomial fromNumber: aNumber! !

!Variable methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 16:22'!
adaptFraction: aFraction
	^ Monomial fromNumber: aFraction! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 18:12'!
adaptInteger: anInteger
	^ Monomial fromNumber: anInteger! !

!Variable methodsFor: 'converting' stamp: 'ary 5/10/98 14:25'!
adaptMonicMonomial: aMonicMonomial
	^ aMonicMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 17:39'!
adaptMonomial: aMonomial
	^ aMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 18:13'!
adaptPolynomial: aPolynomial
	^ aPolynomial! !

!Variable methodsFor: 'converting' stamp: 'ari y r++ 6/26/1998 07:42'!
adaptToAlgebraicNumber
	^ self asMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 6/18/1998 17:38'!
adaptToFloat
	^ self asMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ y ary 4/26/98 16:21'!
adaptToFraction
	^ self asMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 18:12'!
adaptToInteger
	^ self asMonomial! !

!Variable methodsFor: 'converting' stamp: 'ary 5/10/98 14:25'!
adaptToMonicMonomial
	^ self asMonicMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 17:39'!
adaptToMonomial
	^ self asMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 4/25/98 18:13'!
adaptToPolynomial
	^ self asPolynomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 5/3/98 14:05'!
adaptToVariable
	^ self asMonicMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 5/3/98 14:05'!
adaptVariable: aVariable
	^ aVariable asMonicMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 5/3/98 14:05'!
asMonicMonomial
	" anwer a MonicMonomial representing me"
	^ MonicMonomial fromVariable: self copy! !

!Variable methodsFor: 'converting' stamp: 'r++ 5/3/98 15:43'!
asMonomial
	" anwer a MonicMonomial representing me"
	^ Monomial fromMonicMonomial: self asMonicMonomial! !

!Variable methodsFor: 'converting' stamp: 'r++ 5/3/98 14:03'!
asPolynomial
	" anwer a MonicMonomial representing me"
	^ Polynomial fromMonicMonomial: self asMonicMonomial! !

!Variable methodsFor: 'printing'!
printOn: aStream
	self name printOn: aStream.
! !

!Variable methodsFor: 'evaluating'!
valueAt: anObject
	"public - my evaluation method is:"
	^ anObject! !


!RaisedVariable commentStamp: '<historical>' prior: 0!
I'm a subclass of Variable, I'm borned to be used in Monomials and Polynomials.
In addition to what a standard Variable can do, I can be #raisedToInteger:!
]style[(18 8 27 9 5 11 1 1 57 17)f1,f1LVariable Comment;,f1,f1LMonomial Comment. Polynomial Comment;,f1,f1LMonomial Comment. Polynomial Comment;,f1,f1LMonomial Comment. Polynomial Comment;,f1,f1LRaisedVariable raisedToInteger:;!

!RaisedVariable methodsFor: 'accesing' stamp: 'r++ 5/11/98 02:58'!
deg
	" public - answer my degree, if it was not initialized assume it's 1"
	degree ifNil: [self deg: 1].
	^ degree! !

!RaisedVariable methodsFor: 'accesing' stamp: 'r++ 5/11/98 02:58'!
deg: anInteger
	" public - set my degree"
	degree _ anInteger.
! !

!RaisedVariable methodsFor: 'evaluating'!
valueAt: anObject
	"my evaluation method is:"
	^ (super valueAt: anObject) raisedToInteger: self deg! !

!RaisedVariable methodsFor: 'arithmetic'!
raisedToInteger: anInteger
	" public - answer myself raised to the aNumberth power"
	^ self clone deg: self deg*anInteger! !

!RaisedVariable methodsFor: 'arithmetic' stamp: 'ari y r++ 6/26/1998 05:17'!
reciprocal
	"public - my reciprocal is a copy of myself but with degree negated"
	^self clone deg: self deg negated! !

!RaisedVariable methodsFor: 'printing' stamp: 'r++ 5/11/98 02:56'!
printOn: aStream
	super printOn: aStream.
	self deg ~= 1 ifTrue: [ aStream nextPut: $^. self deg printOn: aStream]! !

!RaisedVariable methodsFor: 'comparing' stamp: 'r++ 5/11/98 02:54'!
= aVariable
	^ super = aVariable and: [
		self deg = aVariable deg]! !

!RaisedVariable methodsFor: 'comparing' stamp: 'r++ 5/11/98 02:53'!
hash
	^ (super hash * self deg) hash! !

!RaisedVariable methodsFor: 'comparing'!
lexSmallerThan: aVariable
	^ (super lexSmallerThan: aVariable) or: [
		self deg < aVariable deg and: [
		self name = aVariable name]]! !


!Variable class reorganize!
('initialization' initialize)
('instance creation' name:)
('accessing' sortBlock)
!


!Variable class methodsFor: 'initialization' stamp: 'r++ 6/17/1998 13:23'!
initialize
	"Variable initialize"
	SortBlock _ [:a :b | b lexSmallerOrEqualThan: a]! !

!Variable class methodsFor: 'instance creation' stamp: 'r++ 5/11/98 02:56'!
name: aString
	^ self new name: aString.
! !

!Variable class methodsFor: 'accessing' stamp: 'ari y r++ 6/24/1998 23:17'!
sortBlock
	^ SortBlock! !


!RaisedVariable class methodsFor: 'instance creation' stamp: 'r++ 5/11/98 02:57'!
name: aSymbol deg: aNumber
	^ (super name: aSymbol) deg: aNumber! !


MonicMonomial initialize!
Variable initialize!
